/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
 创建人   : joe Song
 创建时间 : 2016-03-10
 说明     : 公用的图片预览页面 
*********************************************************/
(function () {
    'use strict';
    xrmApp.controller("ImagePreviewerController", ['$scope', '$stateParams', 'rt', '$timeout', '$rootScope', ImagePreviewerController]);
    function ImagePreviewerController($scope, $stateParams, rt, $timeout, $rootScope) {
        $scope.previewImage = $scope.imgsrc;
    }
})();
/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : joe Song
 创建时间 : 2016-03-10
 说明     : 实体编辑页面控制器
 *********************************************************/

function entityEditController($scope, myService) {
    var $q = myService.$q;
    var $compile = myService.$compile;
    var $state = myService.$state;
    var $stateParams = myService.$stateParams;
    var rt = myService.rt;
    var $ionicHistory = myService.$ionicHistory;
    var $ionicActionSheet = myService.$ionicActionSheet;
    var $rootScope = myService.$rootScope;
    var _vm = $scope.vm = {};

    _init();

    function _init() {
        _vm.isLoading = false;
        _vm.isSaving = false;
        _vm.isShowCloseButton = rt.isNull($ionicHistory.backView());
        _vm.form = {
            type: '',
            data: {},
            picklist: {},
            attachmentList: [],
            approverList: [],
            readerList: [],
            name: rt.newGuid(), // 动态生成表单的名称
            id: rt.isNull($scope.rtIncludeParams) || rt.isNull($scope.rtIncludeParams.rtIncludeId) ? $stateParams.id.split(',')[0] : $scope.rtIncludeParams.rtIncludeId,

            del: _delData, // 删除事件
            save: _saveForm,
            preSave: $scope.preSave ? $scope.preSave : function () {
                return "";
            }, // 表单保存前执行
            load: $scope.reload ? $scope.reload : _loadForm, // 表单加载        
            preLoad: $scope.preLoad ? $scope.preLoad : function () {
            }, // 表单加载前
            preBindFormData: $scope.preBindFormData ? $scope.preBindFormData : function () {
            }, // 表单加载前
            loadComplete: $scope.loadComplete ? $scope.loadComplete : function () {
            }, // 表单加载后
            activate: _activateData, // 激活事件
            deactivate: _deactivateData, // 停用事件
            previewPicture: _previewPicture, //预览图片
            previewPicture2: _previewPicture2, //滑动预览图片
            previewPicture3: _previewPicture3, //预览图片(指定图片src)
            choosePhoto: _choosePhoto, //选择照片
            choosePhotoForItem: _choosePhotoForItem,//选择照片（当页面上存在多个选择照片的按钮时）
            delAttachment: _delAttachment, //删除附件
            delAttachmentForItem:_delAttachmentForItem,//删除附件（当页面上存在多个照片列表时）
            delApprover: _delApprover,//删除审批人
            addApprover: _addApprover, //添加审批人
            getAvatarColor: _getAvatarColor, //审批人头像颜色
            getAvatarName: _getAvatarName,
            flowSubmit: _flowSubmit, //审批流程提交
            delReader: _delReader,//删除日志发送者
            addReader: _addReader, //添加日志发送者
            reportSubmit: _reportSubmit, //工作日志提交
            goBackClick: _goBackClick//返回主菜单
        };

        _vm.staged = {
            isCommitted: false
        };

        $scope.$on('modal.shown', function (event, modal) {
            $rootScope.$broadcast('xrm.modal.shown', modal);
        });

        $scope.$on('popover.shown', function (event, popover) {
            $rootScope.$broadcast('xrm.popover.shown', popover);
        });

        $scope.$on('modal.hidden', function () {
            $rootScope.$broadcast('xrm.modal.hidden');
        });

        $scope.$on('popover.hidden', function () {
            $rootScope.$broadcast('xrm.popover.hidden');
        });
        $scope.$emit("rt-localurlforlog-emit", $state.current.url);
        // 捕获刷新事件
        // $scope.$on('rt-reload-data',function(){
        //      _vm.form.load();
        // });
        //
        // $scope.$on('$ionicView.beforeLeave', function () {
        //     if ($scope.dialog) {
        //         $scope.dialog.hide();
        //     }
        //     _saveStagedData();
        //
        // });
        // 加载选项集合
        _loadPicklist().then(_vm.form.load);
    }

    //将未保存的数据暂存
    function _saveStagedData() {
        if (!rt.isNullOrEmptyString(myService.approvalTypeName) && !_vm.staged.isCommitted && _vm.form.type === 'Create') {
            localStorage.setItem("staged_" + myService.approvalTypeName + "_data", JSON.stringify(_vm.form.data));
            localStorage.setItem("staged_" + myService.approvalTypeName + "_attachmentList", JSON.stringify(_vm.form.attachmentList));
            localStorage.setItem("staged_" + myService.approvalTypeName + "_approverList", JSON.stringify(_vm.form.approverList));
        }
    }

    //提交单据后清除缓存
    function _claerStagedData() {
        localStorage.setItem("staged_" + myService.approvalTypeName + "_data", "");
        localStorage.setItem("staged_" + myService.approvalTypeName + "_attachmentList", "");
        localStorage.setItem("staged_" + myService.approvalTypeName + "_approverList", "");
    }

    //获取上次暂存的数据的数据暂存
    function _getStagedData() {
        var data;
        if (rt.isNullOrEmptyString(myService.approvalTypeName)) {
            return;
        }
        if (rt.isNullOrEmptyString(localStorage.getItem("staged_" + myService.approvalTypeName + "_data"))) {
            return;
        }
        try {
            data = JSON.parse(localStorage.getItem("staged_" + myService.approvalTypeName + "_data"));
            _vm.form.attachmentList = JSON.parse(localStorage.getItem("staged_" + myService.approvalTypeName + "_attachmentList"));
            _vm.form.approverList = JSON.parse(localStorage.getItem("staged_" + myService.approvalTypeName + "_approverList"));
        } catch (e) {

        }

        return data;
    }

    // 加载选项集合
    function _loadPicklist() {
        // @@选项集
        return myService.getPickList().then(function (resp) {
            _vm.form.picklist = resp.data;
        });
    }

    // 加载表单
    function _loadForm() {
        var hasError = false;
        // 加载表单类型
        _vm.form.type = rt.isNull(_vm.form.id) || _vm.form.id.length === 0 ? 'Create' : 'Edit';

        _vm.isLoading = true;

        // 加载前事件
        _vm.form.preLoad();
        if (!rt.isNullOrEmptyString(myService.approvalTypeName)) {
            myService.getEditApprovalList(_vm.form.id, myService.approvalTypeName)
                .then(function (resp) {
                    if (!rt.isNull(resp)) {
                        $scope.vm.form.approverList = resp.data;
                    }
                })
                .catch(function (resp) {
                    rt.showErrorToast(resp.data);
                });
        }

        // 加载前事件
        if (!rt.isNullOrEmptyString(myService.reportTypeName) && _vm.form.type === 'Edit') {
            myService.getEditReaderList(_vm.form.id)
                .then(function (resp) {
                    if (!rt.isNull(resp)) {
                        for (var i = resp.data.length - 1; i >= 0; i--) {
                            $scope.vm.form.readerList.push({
                                OwnerId: {
                                    Name: resp.data[i].ReadByName,
                                    Id: resp.data[i].ReadBy.Id
                                }
                            });
                        }
                    }
                })
                .catch(function (resp) {
                    rt.showErrorToast(resp.data);
                });
        }

        return $q.all([
            myService.getPrivilege(_vm.form.id),
            myService.getData(_vm.form.id)
        ])
            .then(function (responses) {
                _vm.privilege = responses[0].data;
                var data = responses[1].data || {};
                if (_vm.form.type === 'Create') {
                    var stagedData = _getStagedData();
                    if (!rt.isNull(stagedData)) {
                        data = stagedData;
                    }
                }
                _vm.form.preBindFormData(data);
                _vm.form.data = data;

                // 绑定多选字段属性，设置为[]，解决ui-select 的 ngmodel 为null 报错的问题。
                _.each(myService.mutipleSelects, function (item) {
                    if (rt.isNull(_vm.form.data[item])) {
                        _vm.form.data[item] = [];
                    }
                });

                if (_vm.form.type === 'Create') {

                    // 加载关联字段
                    if (!rt.isNull($scope.rtIncludeParams) && !rt.isNull($scope.rtIncludeParams.formAttr)) {
                        _vm.form.data[$scope.rtIncludeParams.formAttr] = {};
                        _vm.form.data[$scope.rtIncludeParams.formAttr].Id = $scope.rtIncludeParams.formAttrValue;
                        _vm.form.data[$scope.rtIncludeParams.formAttr].Name = $scope.rtIncludeParams.formAttrName;
                    }
                }
                _vm.isLoading = false;
            })
            .then(_vm.form.loadComplete)
            .catch(function (resp) {
                _vm.isLoading = false;
            })
            .finally(function () {
                if (!hasError) rt.hideLoadingToast();
                if (rt.isNull(_vm.form.id) || _vm.form.id.length === 0) {
                    _vm.form.id = rt.newGuid();
                    _vm.form.data.Id = _vm.form.id;
                }
            });
    }

    function _getForm() {
        // 获取表单
        var form = $scope[_vm.form.name];
        if ($scope[_vm.form.name] === undefined) {
            form = $scope.$$childTail[_vm.form.name] || $scope.$$childHead[_vm.form.name];
        }

        return form;
    }

    // 保存表单数据
    // createNext: 是否创建下一条记录
    function _saveForm(nextStep) {
        // 执行保存前事件
        var preSaveMessage = _vm.form.preSave(_vm.form.data);
        if (!rt.isNull(preSaveMessage) && preSaveMessage.length > 0) {
            rt.showErrorToast(preSaveMessage);
            return;
        }

        rt.showLoadingToast("正在保存数据...");
        _vm.isSaving = true;
        if (_vm.form.type === 'Create') {
            return $q.all([
                myService.createData(_vm.form.data),
                myService.saveAttachmentList(_vm.form.attachmentList)
            ])
                .then(function (resp) {
                    $rootScope.$broadcast('rt-reload-data');
                    rt.hideLoadingToast();
                    $ionicHistory.goBack();
                }, function (resp) {
                    rt.hideLoadingToast();
                    rt.showErrorToast(resp.data);
                })
                .finally(function () {
                    _vm.isSaving = false;
                });
        }
        else if (_vm.form.type === 'Edit') {
            return $q.all([
                myService.updateData(_vm.form.data),
                myService.saveAttachmentList(_vm.form.attachmentList)
            ])
                .then(function () {
                    $rootScope.$broadcast('rt-reload-data');
                    rt.hideLoadingToast();
                    $ionicHistory.goBack();
                }, function (resp) {
                    rt.hideLoadingToast();
                    rt.showErrorToast(resp.data);
                })
                .finally(function () {
                    _vm.isSaving = false;
                });
        }
    }

    function _activateData() {
        $ionicActionSheet.show({
            titleText: '确认激活选定的记录？',
            buttons: [{ text: '确定' },],
            cancelText: '取消',
            buttonClicked: function (index) {
                rt.showLoadingToast("正在处理...");
                myService.activateData([_vm.form.id])
                    .then(function (resp) {
                        rt.hideLoadingToast();
                        _loadForm();
                    }, function (resp) {
                        rt.hideLoadingToast();
                        rt.showErrorToast(resp.data);
                    });

            }
        });
    }

    function _deactivateData() {
        $ionicActionSheet.show({
            titleText: '确认停用选定的记录？',
            buttons: [{ text: '确定' },],
            cancelText: '取消',
            buttonClicked: function (index) {
                rt.showLoadingToast("正在处理...");
                myService.deactivateData([_vm.form.id])
                    .then(function (resp) {
                        rt.hideLoadingToast();
                        _loadForm();
                    }, function (resp) {
                        rt.hideLoadingToast();
                        rt.showErrorToast(resp.data);
                    });

            }
        });
    }

    function _delData() {
        $ionicActionSheet.show({
            titleText: '是否删除',
            buttons: [{ text: '确定' },],
            cancelText: '取消',
            buttonClicked: function (index) {
                rt.showLoadingToast("正在处理...");
                myService.delData([_vm.form.id])
                    .then(function (resp) {
                        $rootScope.$broadcast('rt-del-reload-data');
                        rt.hideLoadingToast();
                        $ionicHistory.goBack();
                    }, function (resp) {
                        rt.hideLoadingToast();
                        rt.showErrorToast(resp.data);
                    });

            }
        });
    }

    function _delAttachment(id) {
        rt.showLoadingToast("正在处理...");
        myService.delAttachment(id)
            .then(function (resp) {
                var index = _.findIndex($scope.vm.form.attachmentList, { Id: id });
                if (index >= 0) {
                    $scope.vm.form.attachmentList.splice(index, 1);
                }
                rt.hideLoadingToast();
            }, function (resp) {
                rt.hideLoadingToast();
                rt.showErrorToast(resp.data);
            });
    }

    function _delAttachmentForItem(id, row) {
        rt.showLoadingToast("正在处理...");
        myService.delAttachment(id)
            .then(function (resp) {
                var index = _.findIndex(row.attachmentList, { Id: id });
                if (index >= 0) {
                    row.attachmentList.splice(index, 1);
                }
                rt.hideLoadingToast();
            }, function (resp) {
                rt.hideLoadingToast();
                rt.showErrorToast(resp.data);
            });
    }

    function _choosePhoto(id) {
        rt.takePhoto(800, 80, function (base64Image) {
            if (rt.isNull(_vm.form.attachmentList)) {
                _vm.form.attachmentList = [];
            }
            if (rt.isNull(id)) {
                id = _vm.form.id;
            }
            _vm.form.attachmentList.push({
                "Id": rt.newGuid(),
                "FileBase64Content": base64Image,
                "FileName": "Photo.jpg",
                "ObjectId": id
            });
        });
    };

    function _choosePhotoForItem(row) {
        rt.takePhoto(800, 80, function (base64Image) {
            if (rt.isNull(row.attachmentList)) {
                row.attachmentList = [];
            }
            row.attachmentList.push({
                "Id": rt.newGuid(),
                "FileBase64Content": base64Image,
                "FileName": "Photo.jpg",
                "ObjectId": ""
            });
        });
    };

    function _previewPicture(content) {
        $scope.imgsrc = content;
        rt.createDialog("component/ImagePreviewer/ImagePreviewerView.html", $scope, null)
            .then(function (d) {
                d.show();
            });
    };
    function _previewPicture2(contentList, index) {
        $scope.srcList = contentList;
        $scope.imgsrcList = [];
        for (var i = 0; i < $scope.srcList.length; i++) {
            $scope.imgsrcList.push($scope.srcList[i].FileBase64Content);
        }
        $scope.index = index;
        rt.createDialog("component/ImagePreviewer2/ImagePreviewer2View.html", $scope, null)
            .then(function (d) {
                d.show();
            });
    };
    function _previewPicture3(imageSrc) {
        $scope.imgsrc = imageSrc;
        rt.createDialog("component/ImagePreviewer3/ImagePreviewer3View.html", $scope, null)
            .then(function (d) {
                d.show();
            });
    };
    function _delApprover(index) {
        $scope.vm.form.approverList.splice(index, 1);
    }

    function _addApprover() {
        rt.userWithFrequentLookup($scope, 'flowApproval', false, function (data) {
            if (rt.isNull(data)) return;
            if (rt.isNull($scope.vm.form.approverList)) {
                $scope.vm.form.approverList = [];
            }
            for (var i = 0; i < $scope.vm.form.approverList.length; i++) {
                if ($scope.vm.form.approverList[i].OwnerId.Id == data.id) {
                    rt.showErrorToast("审批人已存在，请勿重复添加！");
                    return;
                }
            }
            $scope.vm.form.approverList.push({
                OwnerId: {
                    Name: data.name,
                    Id: data.id
                }
            });
        });
    }

    var _avatarColors = [
        "#2ec7c9", "#feb358", "#33bc98", "#b6a2de"
    ];

    function _getAvatarColor(index) {
        var i = index % 4;
        return _avatarColors[i];
    }

    function _getAvatarName(name) {
        if (rt.isNull(name)) {
            return "";
        }
        return name.length <= 3 ? name : name.substring(0, 3)
    }

    function _flowSubmit() {
        var hasError = false;
        var preSaveMessage = _vm.form.preSave(_vm.form.data);
        if (!rt.isNull(preSaveMessage) && preSaveMessage.length > 0) {
            rt.showErrorToast(preSaveMessage);
            return;
        }
        rt.showLoadingToast("正在提交单据...");
        if (_vm.form.type === 'Create') {
            _vm.form.data.Id = _vm.form.id;
            return $q.all([
                myService.createData(_vm.form.data),
                myService.saveAttachmentList(_vm.form.attachmentList)
            ]).then(function () {
                return myService.getData(_vm.form.id)
            }).then(function (resp) {
                _vm.form.type = 'Edit';
                _vm.form.data = resp.data;
                var reqData = {
                    ObjectId: _vm.form.id,
                    ObjectName: _vm.form.data.name,
                    ObjectTypeName: myService.approvalTypeName,
                    ApproverList: _vm.form.approverList
                };
                return myService.flowSubmit(reqData);
            }).catch(function (resp) {
                hasError = true;
                rt.hideLoadingToast();
                rt.showErrorToast(resp.data);
            }).finally(function () {
                if (!hasError) {
                    _vm.staged.isCommitted = true; //已经提交成功，不暂存数据
                    $rootScope.$broadcast('rt-reload-data');
                    rt.hideLoadingToast();
                    _claerStagedData();
                    $ionicHistory.currentView($ionicHistory.backView());
                    myService.goFlowReadPage(_vm.form.id);
                }
            });
        }
        else if (_vm.form.type === 'Edit') {
            return $q.all([
                myService.updateData(_vm.form.data),
                myService.saveAttachmentList(_vm.form.attachmentList)
            ]).then(function () {
                var reqData = {
                    ObjectId: _vm.form.id,
                    ObjectName: _vm.form.data.name,
                    ObjectTypeName: myService.approvalTypeName,
                    ApproverList: _vm.form.approverList
                };
                return myService.flowSubmit(reqData);
            }).catch(function (resp) {
                hasError = true;
                rt.hideLoadingToast();
                rt.showErrorToast(resp.data);
            }).finally(function () {
                if (!hasError) {
                    rt.hideLoadingToast();
                    $rootScope.$broadcast('rt-reload-data');
                    _claerStagedData();
                    $ionicHistory.currentView($ionicHistory.backView());
                    myService.goFlowReadPage(_vm.form.id);
                }
            });
        }
    }

    function _delReader(index) {
        $scope.vm.form.readerList.splice(index, 1);
    }

    function _addReader() {
        rt.userWithFrequentLookup($scope, 'workReport', false, function (data) {
            if (rt.isNull(data)) return;
            if (rt.isNull($scope.vm.form.readerList)) {
                $scope.vm.form.readerList = [];
            }
            for (var i = 0; i < $scope.vm.form.readerList.length; i++) {
                if ($scope.vm.form.readerList[i].OwnerId.Id == data.id) {
                    rt.showErrorToast("已存在该发送人，请勿重复添加！");
                    return;
                }
            }
            $scope.vm.form.readerList.push({
                OwnerId: {
                    Name: data.name,
                    Id: data.id
                }
            });
        });
    }

    function _reportSubmit() {
        var hasError = false;
        var preSaveMessage = _vm.form.preSave(_vm.form.data);
        if (!rt.isNull(preSaveMessage) && preSaveMessage.length > 0) {
            rt.showErrorToast(preSaveMessage);
            return;
        }
        rt.showLoadingToast("正在发送...");
        if (_vm.form.type === 'Create') {
            _vm.form.data.Id = _vm.form.id;
            return $q.all([
                myService.createData(_vm.form.data),
                myService.saveAttachmentList(_vm.form.attachmentList)
            ]).then(function () {
                return myService.getData(_vm.form.id)
            }).then(function (resp) {
                _vm.form.type = 'Edit';
                _vm.form.data = resp.data;
                var reqData = {
                    ObjectId: _vm.form.id,
                    ObjectTypeName: myService.reportTypeName,
                    ReaderList: _vm.form.readerList
                };
                return myService.readerSubmit(reqData);
            }).catch(function (resp) {
                hasError = true;
                rt.hideLoadingToast();
                rt.showErrorToast(resp.data);
            }).finally(function () {
                if (!hasError) {
                    _vm.staged.isCommitted = true; //已经提交成功，不暂存数据
                    rt.hideLoadingToast();
                    $rootScope.$broadcast('rt-reload-data');
                    $ionicHistory.currentView($ionicHistory.backView());
                    myService.goReportReadPage(_vm.form.id);
                }
            });
        }
        else if (_vm.form.type === 'Edit') {
            return $q.all([
                myService.updateData(_vm.form.data),
                myService.saveAttachmentList(_vm.form.attachmentList)
            ]).then(function () {
                var reqData = {
                    ObjectId: _vm.form.id,
                    ObjectTypeName: myService.reportTypeName,
                    ReaderList: _vm.form.readerList
                };
                return myService.readerSubmit(reqData);
            }).catch(function (resp) {
                hasError = true;
                rt.hideLoadingToast();
                rt.showErrorToast(resp.data);
            }).finally(function () {
                if (!hasError) {
                    rt.hideLoadingToast();
                    $rootScope.$broadcast('rt-reload-data');
                    $ionicHistory.currentView($ionicHistory.backView());
                    $ionicHistory.goBack();
                }
            });
        }
    }

    function _goBackClick() {
        $state.go("app-close");
    }
}
/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : joe Song
 创建时间 : 2016-03-10
 说明     : 自定义实体的列表页面
*********************************************************/

function entityListController($scope, myService) {
    var $q = myService.$q;
    var $compile = myService.$compile;
    var $state = myService.$state;
    var $stateParams = myService.$stateParams;
    var rt = myService.rt;
    var $ionicActionSheet = myService.$ionicActionSheet;
    var $ionicHistory = myService.$ionicHistory;
    var $ionicPopover = myService.$ionicPopover;
    var $rootScope = myService.$rootScope;

    var _vm = $scope.vm = {};
    _init();

    function _init() {
        _vm.isLoading = false;
        _vm.isShowCloseButton = rt.isNull($ionicHistory.backView());
        _vm.view = {
            type: !rt.isNull($scope.rtIncludeParams) ? "grid" : "default", // 视图的类型：默认视图、关联视图。根据是否存在父级字段来判断
            list: [], // 视图列表
            selectedView: {}, // 选中视图
            searchText: '', // 视图快速搜索条件
            sortField: '', // 视图排序字段
            selectedIds: [], // 选中的行
            searchList: [],

            search: _search,
            chooseView: _chooseView,
            loadMoreData: _loadMoreData,
            getAvatarColor: _getAvatarColor,
            getAvatarName: _getAvatarName,
            getAvatarName2: _getAvatarName2,
            getAvatarName3: _getAvatarName3
        };

        // 获取表格自动高度
        _vm.view.autoHeight = _vm.view.type == 'default' ? myService.getDefaultAutoHeight() : -1;

        _vm.page = {
            index: 1,
            size: rt.getPaginationSize(),
            recordCount: 0
        };

        _vm.actions = {
            activate: _activateData, // 激活事件
            deactivate: _deactivateData, // 停用事件
            del: _delData, // 删除事件

            goBackClick: _goBackClick,
            preBindListData: $scope.preBindListData ? $scope.preBindListData : function () { }, // 表单加载前
            loadComplete: $scope.loadComplete ? $scope.loadComplete : function () { }, // 表单加载后
        };

        var on_reload = $rootScope.$on('rt-reload-data', function () {
            _vm.view.search();
        });

        var on_del_reload = $rootScope.$on('rt-del-reload-data', function () {
            _vm.view.search();
        });

        $scope.$on('$ionicView.unloaded', function () {
            if (on_reload != undefined) {
                on_reload();
            }

            if (on_del_reload != undefined) {
                on_del_reload();
            }
        });

        // 选中视图后加载数据
        $scope.$watch('vm.view.selectedView', function () {
            if (_vm.view.selectedView) {
                _vm.view.search();
            }
        });

        $scope.$on('modal.shown', function (event, modal) {
            $rootScope.$broadcast('xrm.modal.shown', modal);
        });

        $scope.$on('popover.shown', function (event, popover) {
            $rootScope.$broadcast('xrm.popover.shown', popover);
        });

        $scope.$on('modal.hidden', function () {
            $rootScope.$broadcast('xrm.modal.hidden');
        });

        $scope.$on('popover.hidden', function () {
            $rootScope.$broadcast('xrm.popover.hidden');
        });
        $scope.$emit("rt-localurlforlog-emit", $state.current.url);
        _vm.isLoading = true;
        _loadPrivilege()// 检查实体权限
            .then(_loadPicklist)// 加载选项集合
            .then(_loadView)// 加载视图
            .then(function () {
                _vm.isLoading = false;
            }, function (resp) {
                _vm.isLoading = false;
                rt.showErrorToast(resp.data);
            });


    }

    function _goBackClick() {
        $state.go("app-close");
    }

    function _loadPicklist() {
        return myService.getPickList().then(function (resp) {
            _vm.picklist = resp.data;
        });
    }

    function _loadPrivilege() {
        return myService.getPrivilege().then(function (resp) {
            _vm.privilege = resp.data;
        });
    }

    // 加载视图列表
    function _loadView() {
        var loadViewFun;
        switch (_vm.view.type) {
            case "default":
                loadViewFun = myService.getViewList;
                break;
            case "grid":
                loadViewFun = myService.getAssociatedGridViewList;
                break;
            default:
                var deferred = $q.defer();
                deferred.reject("未提供该类视图查询。");
                return deferred.promise;
        }

        return loadViewFun.call(myService, $scope.viewTag)
            .then(function (resp) {
                _vm.view.list = resp.data;
                if (_vm.view.list.length > 0) {
                    _vm.view.selectedView = _vm.view.list[0];
                }
            });
    }

    function _chooseView(selectedButtons) {
        var selectedButtons = _.map(_vm.view.list, function (v) {
            return { text: v.ViewName };
        });

        $ionicActionSheet.show({
            buttons: selectedButtons,
            titleText: '选择视图',
            cancelText: '取消',
            cancel: function () {
            },
            buttonClicked: function (index) {
                _vm.view.selectedView = _vm.view.list[index];
                _search();
                return true;
            }
        });
    }

    var _popoverchooseViewsTemplate =
        '<ion-popover-view style="height:{{3 * 44 + 6}}px;">' +
        '    <ion-content style="height:{{3 * 44}}px;"> ' +
        '        <ion-list> ' +
        '            <ion-item ng-repeat="v in vm.view.list"style="text-align:center;" ng-click="vm.view.chooseView2Click($index)"> ' +
        '                <span class="positive" >{{v.ViewName}}</span> ' +
        '                <i class="ion ion-android-done positive" ng-show="vm.view.selectedView.ViewName == v.ViewName"></i> ' +
        '            </ion-item> ' +
        '        </ion-list> ' +
        '    </ion-content> ' +
        '</ion-popover-view>';
    $scope.popoverchooseViews = $ionicPopover.fromTemplate(_popoverchooseViewsTemplate, {
        scope: $scope
    });

    $scope.vm.view.chooseView2 = function ($event) {
        $scope.popoverchooseViews.show($event);
    };

    $scope.vm.view.chooseView2Click = function (index) {
        $scope.vm.view.selectedView = $scope.vm.view.list[index];
        $scope.vm.view.search();
        $scope.popoverchooseViews.hide();
    };

    function _search() {
        _vm.page.index = 1;

        _loadData();

        $scope.$broadcast('scroll.refreshComplete');
    }

    var _selectedViewHasMoreData = true;
    function _loadMoreData() {
        if (!_selectedViewHasMoreData) {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return;
        }

        _vm.page.index++;

        _loadData();
    }
    // 加载视图数据
    function _loadData() {
        var view = _vm.view.selectedView;
        if (rt.isNull(view) || rt.isNull(view.Id)) {
            return;
        }

        // 默认视图
        if (_vm.view.type == 'default') {
            _vm.isLoading = true;
            myService.getViewData(view.Id, _vm.view.searchText, _vm.view.searchList, _vm.view.sortField, _vm.page.size, _vm.page.index)
                .then(function (resp) {
                    if (resp.data.DataList.length < _vm.page.size) {
                        _selectedViewHasMoreData = false;
                    } else {
                        _selectedViewHasMoreData = true;
                    }
                    _vm.actions.preBindListData(resp.data.DataList);

                    if (_vm.page.index == 1) {
                        _vm.data = resp.data.DataList;
                    } else {
                        _vm.data = _vm.data.concat(resp.data.DataList);
                    }
                    _vm.page.recordCount = resp.data.TotalRecords;
                    _vm.isLoading = false;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }, function (resp) {
                    _vm.isLoading = false;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    rt.showErrorToast(resp.data);
                }).then(_vm.actions.loadComplete, function (resp) {
                    _vm.isLoading = false;
                    rt.showErrorToast(resp.data);
                });
        }

        // 关联视图
        if (_vm.view.type == 'grid') {
            var relatedAttr = $scope.rtIncludeParams.relatedAttr;
            var relatedAttrValue = $scope.$parent.vm.form.id;
            _vm.isLoading = true;
            myService.getViewData(view.Id, _vm.view.searchText, [{ Key: relatedAttr, Value: relatedAttrValue, Type: 1 }], _vm.view.sortField, _vm.page.size, _vm.page.index)
                .then(function (resp) {
                    if (resp.data.DataList.length < _vm.page.size) {
                        _selectedViewHasMoreData = false;
                    } else {
                        _selectedViewHasMoreData = true;
                    }
                    if (_vm.page.index == 1) {
                        _vm.data = resp.data.DataList;
                    } else {
                        _vm.data.push(resp.data.DataList);
                    }
                    _vm.page.recordCount = resp.data.TotalRecords;
                    _vm.isLoading = false;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                }, function (resp) {
                    _vm.isLoading = false;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    rt.showErrorToast(resp.data);
                }).then(_vm.actions.loadComplete, function (resp) {
                    _vm.isLoading = false;
                    rt.showErrorToast(resp.data);
                });
        }
    }

    function _activateData() {
        $ionicActionSheet.show({
            titleText: '确认激活选定的记录？',
            buttons: [{ text: '确定' },],
            cancelText: '取消',
            buttonClicked: function (index) {
                rt.showLoadingToast("正在处理...");
                myService.activateData([_vm.form.id])
                    .then(function (resp) {
                        rt.hideLoadingToast();
                        _loadData();
                    }, function (resp) {
                        rt.hideLoadingToast();
                        rt.showErrorToast(resp.data);
                    });

            }
        });
    }

    function _deactivateData() {
        $ionicActionSheet.show({
            titleText: '确认停用选定的记录？',
            buttons: [{ text: '确定' },],
            cancelText: '取消',
            buttonClicked: function (index) {
                rt.showLoadingToast("正在处理...");
                myService.deactivateData([_vm.form.id])
                    .then(function (resp) {
                        _loadData();
                        rt.hideLoadingToast();
                    }, function (resp) {
                        rt.hideLoadingToast();
                        rt.showErrorToast(resp.data);
                    });

            }
        });
    }

    function _delData() {
        $ionicActionSheet.show({
            titleText: '是否删除',
            buttons: [{ text: '确定' },],
            cancelText: '取消',
            buttonClicked: function (index) {
                rt.showLoadingToast("正在处理...");
                myService.delData([_vm.form.id])
                    .then(function (resp) {
                        _loadData();
                        rt.hideLoadingToast();
                    }, function (resp) {
                        rt.hideLoadingToast();
                        rt.showErrorToast(resp.data);
                    });

            }
        });
    }

    var _avatarColors = [
        "#2ec7c9", "#feb358", "#33bc98", "#b6a2de"
    ];

    function _getAvatarColor(index) {
        var i = index % 4;
        return _avatarColors[i];
    }

    function _getAvatarName(name) {
        if (rt.isNull(name)) {
            return "";
        }
        return name.length <= 3 ? name : name.substring(0, 3)
    }

    function _getAvatarName2(name) {
        if (rt.isNull(name)) {
            return "";
        }
        return name.length <= 2 ? name : name.substring(1, 3)
    }

    function _getAvatarName3(name) {
        if (rt.isNull(name)) {
            return "";
        }
        return name.length <= 3 ? name : name.substring(0, 3)
    }
}
/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : joe Song
 创建时间 : 2016-03-10
 说明     : 实体编辑页面控制器
 *********************************************************/

function entityReadOnlyController($scope, myService, $ionicPopup) {
    var $q = myService.$q;
    var $compile = myService.$compile;
    var $state = myService.$state;
    var $stateParams = myService.$stateParams;
    var rt = myService.rt;
    var $ionicHistory = myService.$ionicHistory;
    var $ionicActionSheet = myService.$ionicActionSheet;
    var $rootScope = myService.$rootScope;

    var _vm = $scope.vm = {};
    var _isFirstLoad = true;//是否第一次加载


    var _c = 0;
    _init();

    function _init() {
        _vm.isLoading = false;
        _vm.isShowCloseButton = rt.isNull($ionicHistory.backView());
        _vm.form = {
            type: '',
            data: {},
            picklist: {},
            name: rt.newGuid(), // 动态生成表单的名称
            id: rt.isNull($scope.rtIncludeParams) || rt.isNull($scope.rtIncludeParams.rtIncludeId) ? $stateParams.id.split(',')[0] : $scope.rtIncludeParams.rtIncludeId,
            needApproval: false,

            del: _delData, // 删除事件
            save: _saveForm,
            preSave: $scope.preSave ? $scope.preSave : function () {
                return "";
            }, // 表单保存前执行
            load: $scope.reload ? $scope.reload : _loadForm, // 表单加载        
            preLoad: $scope.preLoad ? $scope.preLoad : function () {
            }, // 表单加载前
            preBindFormData: $scope.preBindFormData ? $scope.preBindFormData : function () {
            }, // 表单数据绑定前
            postBindFormData: $scope.preBindFormData ? $scope.preBindFormData : function () {
            }, // 表单数据绑定后
            loadComplete: $scope.loadComplete ? $scope.loadComplete : function () {
            }, // 表单加载后
            activate: _activateData, // 激活事件
            deactivate: _deactivateData, // 停用事件

            previewPicture: _previewPicture, //预览图片
            previewPicture2: _previewPicture2, //滑动预览图片
            getAvatarColor: _getAvatarColor,
            getAvatarName: _getAvatarName,
            getAvatarName2: _getAvatarName2,
            getAvatarName3: _getAvatarName3,
            flowApprove: _flowApprove,
            flowReject: _flowReject,
            flowRecall: _flowRecall,
            flowTransmit: _flowTransmit,

            goBackClick: _goBackClick//返回主菜单
        };

        var on_reload = $rootScope.$on('rt-reload-data', function () {
            _vm.form.load();
        });

        $scope.$on('$ionicView.unloaded', function () {
            if (on_reload != undefined) {
                on_reload();
            }

        });

        $scope.$on('$ionicView.beforeLeave', function () {
            if ($scope.dialog) {
                $scope.dialog.hide();
            }
        });

        $scope.$on('modal.shown', function (event, modal) {
            $rootScope.$broadcast('xrm.modal.shown', modal);
        });

        $scope.$on('popover.shown', function (event, popover) {
            $rootScope.$broadcast('xrm.popover.shown', popover);
        });

        $scope.$on('modal.hidden', function () {
            $rootScope.$broadcast('xrm.modal.hidden');
        });

        $scope.$on('popover.hidden', function () {
            $rootScope.$broadcast('xrm.popover.hidden');
        });
        $scope.$emit("rt-localurlforlog-emit", $state.current.url);

        $scope.$on('$ionicView.afterEnter', function () {
            if (_isFirstLoad) {
                _loadPicklist().then(_vm.form.load);
                _isFirstLoad = false;
            }
        });
    }

    // 加载选项集合
    function _loadPicklist() {
        // @@选项集
        return myService.getPickList().then(function (resp) {
            _vm.picklist = resp.data;
        });
    }

    // 加载表单
    function _loadForm() {
        // 加载表单类型
        _vm.form.type = rt.isNull(_vm.form.id) || _vm.form.id.length === 0 ? 'Create' : 'Edit';

        _vm.isLoading = true;

        // 加载前事件
        _vm.form.preLoad();

        if (!rt.isNullOrEmptyString(myService.approvalTypeName)) {
            myService.getApprovalStatus($scope.vm.form.id)
                .then(function (resp) {
                    if (!rt.isNull(resp)) {
                        $scope.vm.form.approvalStatus = resp.data.ApprovalStatus;
                        $scope.vm.form.approverList = resp.data.ApproverList;
                    }

                    $scope.vm.form.isFlowApprover = !rt.isNull($scope.vm.form.approvalStatus.ApprovingBy)
                        && rt.isSameGuid($scope.vm.form.approvalStatus.ApprovingBy.Id, rt.getUserId())
                        && $scope.vm.form.approvalStatus.approval_status.Value == 2;

                    $scope.vm.form.isFlowSubmitter = rt.isSameGuid($scope.vm.form.approvalStatus.SubmittedBy.Id, rt.getUserId())
                        && $scope.vm.form.approvalStatus.approval_status.Value == 2;
                })
                .catch(function (resp) {
                    rt.showErrorToast(resp.data);
                });
        }

        return $q.all([
            myService.getPrivilege(_vm.form.id),
            myService.getData(_vm.form.id)
        ])
            .then(function (responses) {
                _vm.privilege = responses[0].data;

                _vm.form.preBindFormData(responses[1].data || {});
                _vm.form.data = responses[1].data || {};
                _vm.form.postBindFormData(responses[1].data || {});
                // 绑定多选字段属性，设置为[]，解决ui-select 的 ngmodel 为null 报错的问题。
                _.each(myService.mutipleSelects, function (item) {
                    if (rt.isNull(_vm.form.data[item])) {
                        _vm.form.data[item] = [];
                    }
                });

                if (_vm.form.type === 'Create') {

                    // 加载关联字段
                    if (!rt.isNull($scope.rtIncludeParams) && !rt.isNull($scope.rtIncludeParams.formAttr)) {
                        _vm.form.data[$scope.rtIncludeParams.formAttr] = {};
                        _vm.form.data[$scope.rtIncludeParams.formAttr].Id = $scope.rtIncludeParams.formAttrValue;
                        _vm.form.data[$scope.rtIncludeParams.formAttr].Name = $scope.rtIncludeParams.formAttrName;
                    }
                }
                _vm.isLoading = false;
            }).then(_vm.form.loadComplete, function (resp) {
                _vm.isLoading = false;
                rt.showErrorToast(resp.data);
            });
    }

    function _getForm() {
        // 获取表单
        var form = $scope[_vm.form.name];
        if ($scope[_vm.form.name] === undefined) {
            form = $scope.$$childTail[_vm.form.name] || $scope.$$childHead[_vm.form.name];
        }

        return form;
    }

    // 保存表单数据
    // createNext: 是否创建下一条记录
    function _saveForm(nextStep) {
        // 执行保存前事件
        var preSaveMessage = _vm.form.preSave(_vm.form.data);
        if (!rt.isNull(preSaveMessage) && preSaveMessage.length > 0) {
            var deferred = $q.defer();
            deferred.reject(preSaveMessage);
            return deferred.promise;
        }

        rt.showLoadingToast("正在保存数据...");
        if (_vm.form.type === 'Create') {

            // 创建记录需要在会员端创建记录标识
            if (rt.isNull(_vm.form.data.Id) || _vm.form.data.Id.length === 0) {
                _vm.form.data.Id = rt.newGuid();
            }

            return myService.createData(_vm.form.data)
                .then(function (resp) {
                    rt.hideLoadingToast();
                    $ionicHistory.goBack();
                }, function (resp) {
                    rt.hideLoadingToast();
                    rt.showErrorToast(resp.data);
                });
        }
        else if (_vm.form.type === 'Edit') {
            return myService.updateData(_vm.form.data)
                .then(function () {
                    rt.hideLoadingToast();
                    $ionicHistory.goBack();
                }, function (resp) {
                    rt.hideLoadingToast();
                    rt.showErrorToast(resp.data);
                });
        }
    }

    function _activateData() {
        $ionicActionSheet.show({
            titleText: '确认激活选定的记录？',
            buttons: [{ text: '确定' },],
            cancelText: '取消',
            buttonClicked: function (index) {
                rt.showLoadingToast("正在处理...");
                myService.activateData([_vm.form.id])
                    .then(function (resp) {
                        rt.hideLoadingToast();
                        _loadForm();
                    }, function (resp) {
                        rt.hideLoadingToast();
                        rt.showErrorToast(resp.data);
                    });

            }
        });
    }

    function _deactivateData() {
        $ionicActionSheet.show({
            titleText: '确认停用选定的记录？',
            buttons: [{ text: '确定' },],
            cancelText: '取消',
            buttonClicked: function (index) {
                rt.showLoadingToast("正在处理...");
                myService.deactivateData([_vm.form.id])
                    .then(function (resp) {
                        rt.hideLoadingToast();
                        _loadForm();
                    }, function (resp) {
                        rt.hideLoadingToast();
                        rt.showErrorToast(resp.data);
                    });

            }
        });
    }

    function _delData() {
        $ionicActionSheet.show({
            titleText: '是否删除',
            buttons: [{ text: '确定' },],
            cancelText: '取消',
            buttonClicked: function (index) {
                rt.showLoadingToast("正在处理...");
                myService.delData([_vm.form.id])
                    .then(function (resp) {
                        $rootScope.$broadcast('rt-del-reload-data');
                        rt.hideLoadingToast();
                        $ionicHistory.goBack();
                    }, function (resp) {
                        rt.hideLoadingToast();
                        rt.showErrorToast(resp.data);
                    });

            }
        });
    }

    function _previewPicture(content) {
        $scope.imgsrc = content;
        rt.createDialog("component/ImagePreviewer/ImagePreviewerView.html", $scope, null)
            .then(function (d) {
                d.show();
            });
    };

    function _previewPicture2(contentList, index) {
        $scope.srcList = contentList;
        $scope.imgsrcList = [];
        for (var i = 0; i < $scope.srcList.length; i++) {
            $scope.imgsrcList.push($scope.srcList[i].FileBase64Content);
        }
        $scope.index = index;
        rt.createDialog("component/ImagePreviewer2/ImagePreviewer2View.html", $scope, null)
            .then(function (d) {
                d.show();
            });
    };

    var _avatarColors = [
        "#2ec7c9", "#feb358", "#33bc98", "#b6a2de"
    ];

    function _getAvatarColor(index) {
        var i = index % 4;
        return _avatarColors[i];
    }

    function _getAvatarName(name) {
        if (rt.isNull(name)) {
            return "";
        }
        return name.length <= 3 ? name : name.substring(0, 3)
    }

    function _getAvatarName2(name) {
        if (rt.isNull(name)) {
            return "";
        }
        return name.length <= 2 ? name : name.substring(1, 3)
    }

    function _getAvatarName3(name) {
        if (rt.isNull(name)) {
            return "";
        }
        return name.length <= 3 ? name : name.substring(0, 3)
    }

    function _flowApprove() {
        var myPopup = $ionicPopup.show({
            template: '<input type="text" ng-model="vm.form.approvalStatus.remark">',
            title: '请输入同意理由(非必输)',
            scope: $scope,
            buttons: [
                {
                    text: '取消',
                    onTap: function () {
                        $rootScope.$broadcast('xrm.popup.hidden');
                    }
                },
                {
                    text: '确认',
                    type: 'button-positive',
                    onTap: function () {
                        $rootScope.$broadcast('xrm.popup.hidden');
                        rt.showLoadingToast("正在处理...");
                        myService.flowApprove(_vm.form.approvalStatus)
                            .then(function (resp) {
                                _loadForm();
                                $rootScope.$broadcast('rt-reload-data');
                                rt.hideLoadingToast();
                            }, function (resp) {
                                rt.hideLoadingToast();
                                rt.showErrorToast(resp.data);
                            });
                    }
                }
            ]
        });

        $rootScope.$broadcast('xrm.popup.shown', myPopup);
    }

    function _flowReject() {
        var myPopup = $ionicPopup.show({
            template: '<input type="text" ng-model="vm.form.approvalStatus.remark">',
            title: '请输入拒绝理由(非必输)',
            scope: $scope,
            buttons: [
                {
                    text: '取消',
                    onTap: function () {
                        $rootScope.$broadcast('xrm.popup.hidden');
                    }
                },
                {
                    text: '确认',
                    type: 'button-positive',
                    onTap: function () {
                        $rootScope.$broadcast('xrm.popup.hidden');
                        rt.showLoadingToast("正在处理...");
                        myService.flowReject(_vm.form.approvalStatus)
                            .then(function (resp) {
                                _loadForm();
                                $rootScope.$broadcast('rt-reload-data');
                                rt.hideLoadingToast();
                            }, function (resp) {
                                rt.hideLoadingToast();
                                rt.showErrorToast(resp.data);
                            });
                    }
                }
            ]
        });

        $rootScope.$broadcast('xrm.popup.shown', myPopup);
    }

    function _flowRecall() {
        var myPopup = $ionicPopup.show({
            template: '<input type="text" ng-model="vm.form.approvalStatus.remark">',
            title: '请输入撤销理由(非必输)',
            scope: $scope,
            buttons: [
                {
                    text: '取消',
                    onTap: function () {
                        $rootScope.$broadcast('xrm.popup.hidden');
                    }
                },
                {
                    text: '确认',
                    type: 'button-positive',
                    onTap: function () {
                        $rootScope.$broadcast('xrm.popup.hidden');
                        rt.showLoadingToast("正在处理...");
                        myService.flowRecall(_vm.form.approvalStatus)
                            .then(function (resp) {
                                _loadForm();
                                $rootScope.$broadcast('rt-reload-data');
                                rt.hideLoadingToast();
                            }, function (resp) {
                                rt.hideLoadingToast();
                                rt.showErrorToast(resp.data);
                            });
                    }
                }
            ]
        });

        $rootScope.$broadcast('xrm.popup.shown', myPopup);
    }

    function _flowTransmit() {
        var myPopup = $ionicPopup.show({
            template: '<input type="text" ng-model="vm.form.approvalStatus.remark">',
            title: '请输入转发理由(非必输)',
            scope: $scope,
            buttons: [
                {
                    text: '取消',
                    onTap: function () {
                        $rootScope.$broadcast('xrm.popup.hidden');
                    }
                },
                {
                    text: '确认',
                    type: 'button-positive',
                    onTap: function () {
                        $rootScope.$broadcast('xrm.popup.hidden');
                        rt.userWithFrequentLookup($scope, 'flowTransmit', false, function (data) {
                            if (!rt.isNull(data)) {
                                myService.flowTransmit(_vm.form.approvalStatus, data.id)
                                    .then(function (resp) {
                                        _loadForm();
                                        $rootScope.$broadcast('rt-reload-data');
                                        rt.hideLoadingToast();
                                    }, function (resp) {
                                        rt.hideLoadingToast();
                                        rt.showErrorToast(resp.data);
                                    });
                            }
                        });
                    }
                }
            ]
        });

        $rootScope.$broadcast('xrm.popup.shown', myPopup);
    }

    function _goBackClick() {
        $state.go("app-close");
    }
}
/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : joe Song
 创建时间 : 2016-03-10
 说明     : 自定义的报表查询页面
*********************************************************/

function reportListController($scope, myService, $location, $compile) {
    var $q = myService.$q;
    var $compile = myService.$compile;
    var $state = myService.$state;
    var $stateParams = myService.$stateParams;
    var rt = myService.rt;
    var $ionicActionSheet = myService.$ionicActionSheet;
    var $ionicHistory = myService.$ionicHistory;
    var $ionicPopover = myService.$ionicPopover;
    var $rootScope = myService.$rootScope;

    var _vm = $scope.vm = {};
    _init();

    function _init() {
        _vm.isLoading = false;
        _vm.preventLoading = false;
        _vm.isShowCloseButton = rt.isNull($ionicHistory.backView());
        _vm.pageTitle = '';
        _vm.view = {
            list: [], // 视图列表
            selectedView: {}, // 选中视图
            searchText: '', // 视图快速搜索条件
            sortField: '', // 视图排序字段
            selectedIds: [], // 选中的行
            searchList: []
        };


        _vm.page = {
            index: 1,
            size: rt.getPaginationSize(),
            recordCount: 0
        };

        _vm.actions = {
            search: _search,
            loadMoreData: _loadMoreData,
            goBackClick: _goBackClick,
            preBindListData: $scope.preBindListData ? $scope.preBindListData : function () { }, // 表单加载前
            loadComplete: $scope.loadComplete ? $scope.loadComplete : function () { }, // 表单加载后
        };

        _vm.actions.getReportData = function () {
            return myService.getDataList($scope.vm.searchList, $scope.vm.page.index, $scope.vm.page.size);
        };

        var on_reload = $rootScope.$on('rt-reload-data', function () {
            _vm.actions.search();
        });

        var on_del_reload = $rootScope.$on('rt-del-reload-data', function () {
            _vm.actions.search();
        });

        $scope.$on('$ionicView.unloaded', function () {
            if (on_reload != undefined) {
                on_reload();
            }

            if (on_del_reload != undefined) {
                on_del_reload();
            }
        });

        $scope.$on('modal.shown', function (event, modal) {
            $rootScope.$broadcast('xrm.modal.shown', modal);
        });

        $scope.$on('popover.shown', function (event, popover) {
            $rootScope.$broadcast('xrm.popover.shown', popover);
        });

        $scope.$on('modal.hidden', function () {
            $rootScope.$broadcast('xrm.modal.hidden');
        });

        $scope.$on('popover.hidden', function () {
            $rootScope.$broadcast('xrm.popover.hidden');
        });

        _vm.isLoading = false;
        _loadMobileReportTitle();
        if (!rt.isNull(myService.picklists) && myService.picklists.length > 0) {
            _loadPicklist();
        }
    }

    function _goBackClick() {
        $state.go("app-close");
    }



    var _popoverchooseViewsTemplate =
        '<ion-popover-view style="height:{{3 * 44 + 6}}px;">' +
        '    <ion-content style="height:{{3 * 44}}px;"> ' +
        '        <ion-list> ' +
        '            <ion-item ng-repeat="v in vm.view.list"style="text-align:center;" ng-click="vm.view.chooseView2Click($index)"> ' +
        '                <span class="positive" >{{v.ViewName}}</span> ' +
        '                <i class="ion ion-android-done positive" ng-show="vm.view.selectedView.ViewName == v.ViewName"></i> ' +
        '            </ion-item> ' +
        '        </ion-list> ' +
        '    </ion-content> ' +
        '</ion-popover-view>';
    $scope.popoverchooseViews = $ionicPopover.fromTemplate(_popoverchooseViewsTemplate, {
        scope: $scope
    });

    function _search() {
        _vm.page.index = 1;

        _loadData();

        $scope.$broadcast('scroll.refreshComplete');
    }

    var _selectedViewHasMoreData = true;

    function _loadMoreData() {
        if (!_selectedViewHasMoreData) {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            return;
        }

        _vm.page.index++;

        _loadData();
    }
    // 加载视图数据
    function _loadData() {
        if (_vm.preventLoading) {
            return;
        }

        _vm.isLoading = true;
        _vm.actions.getReportData()
            .then(function (resp) {
                if (resp.data.DataList.length < _vm.page.size) {
                    _selectedViewHasMoreData = false;
                } else {
                    _selectedViewHasMoreData = true;
                }
                _vm.actions.preBindListData(resp.data.DataList);

                if (_vm.page.index == 1) {
                    _vm.data = resp.data.DataList;
                } else {
                    _vm.data = _vm.data.concat(resp.data.DataList);
                }
                _vm.page.recordCount = resp.data.TotalRecords;
                _vm.isLoading = false;
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }, function (resp) {
                _vm.isLoading = false;
                $scope.$broadcast('scroll.infiniteScrollComplete');
                rt.showErrorToast(resp.data);
            }).then(_vm.actions.loadComplete, function (resp) {
                _vm.isLoading = false;
                rt.showErrorToast(resp.data);
            });
    }

    //获取移动报表的title
    function _getMobileReportTitle() {
        var urlStr = $location.url();
        var apiurl = 'api/SystemTitle/GetMobileReportTitleByUrl?urlStr=' + encodeURIComponent(urlStr);
        return rt.get(apiurl);
    }
    //获取移动报表的标题
    function _loadMobileReportTitle() {
        _getMobileReportTitle().then(function (resp) {
            _vm.pageTitle = resp.data;
        }, function (resp) {
            rt.showErrorToast(resp.data);
        });
    }
    //加载选项集
    function _loadPicklist() {
        myService.getPickList().then(function (resp) {
            _vm.picklist = resp.data;
        });
    }

    //获取颜色
    var colorPool = ["#33bc98", "#ff8e00", "#2ec7c9", "#b6a2de", "#ff4242", "#9bc800", "#ffc800"];
    $scope.vm.getRankColor = function (index) {
        return colorPool[index % colorPool.length];
    };

    //是否有五角星
    $scope.vm.isHaveStar = function (index) {
        return parseInt(index) <= 3;
    };

    //获取值占最大值的百分比
    $scope.vm.getPerInMax = function (v, max) {
        if (v >= max) {
            return 1;
        }
        return (parseFloat(v) / max).toFixed(2);
    };


    $ionicPopover.fromTemplateUrl("component/lookup/chooseDateView.html", {
        scope: $scope
    }).then(function (model) {
        $scope.chooseDateModel = model;
    });


    //公用月份选择器 parameter：initMonth(传入月份，不传则默认为当前月)
    $scope.vm.view.chooseDateViews = function (initMonth) {
        var datePlace = document.getElementById("rt-publicChosseDate").innerHTML;
        if (rt.isNullOrEmptyString(rt.trim(datePlace, " "))) {
            var d = new Date();
            var month = moment().format('MM');
            if (rt.isNull($scope.selectedYearFilters)) {
                $scope.selectedYearFilters = d.getFullYear().toString();
            }
            if (rt.isNull($scope.selectedMonthFilters)) {
                if (!rt.isNull(initMonth)) {
                    $scope.selectedMonthFilters = (initMonth < 10 ? '0' + initMonth : initMonth + '').toString();
                } else {
                    $scope.selectedMonthFilters = (month < 10 ? '0' + month : month + '').toString();
                }
            }
            $scope.yearFilters = [{
                id: 1,
                name: d.getFullYear() - 2
            }, {
                    id: 2,
                    name: d.getFullYear() - 1

                }, {
                    id: 3,
                    name: d.getFullYear()
                }];
            document.getElementById("rt-publicChosseDate").appendChild($scope.chooseDateModel.$el[0]);
        } else {
            document.getElementById("rt-publicChosseDate").removeChild(document.getElementById("rt-publicChosseDate").childNodes[0]);
        }

    };
    $scope.closeChooseDateViews = function () {
        var datePlace = document.getElementById("rt-publicChosseDate").innerHTML;
        if (!rt.isNullOrEmptyString(rt.trim(datePlace, " "))) {
            document.getElementById("rt-publicChosseDate").removeChild(document.getElementById("rt-publicChosseDate").childNodes[0]);
        }

    }



}
/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/4/1
 说明     :可滑动预览照片
 *********************************************************/
(function () {
    'use strict';
    xrmApp.controller("ImagePreviewer2Controller", ['$scope', '$stateParams', 'rt', '$timeout', '$rootScope', ImagePreviewer2Controller]);
    function ImagePreviewer2Controller($scope, $stateParams, rt, $timeout, $rootScope) {
        $scope.previewImageList = $scope.imgsrcList;
        $scope.myActiveSlide = $scope.index;
        $scope.top_stype = [];

        $timeout(function () {
            _getImgVail();
        }, 100);
        function _getImgVail() {
            var cssCode = 'slide-img-';
            var hideElement = document.getElementsByClassName('modal-backdrop hide');//先删除页面上存在的元素保证计算正确
            _delelement(hideElement);
            var maxHeight = document.getElementsByClassName('modal image-modal slide-in-up ng-enter active ng-enter-active')[0].clientHeight;
            if (maxHeight > 0) {
                for (var i = 0; i < $scope.previewImageList.length; i++) {
                    var oldcss= document.getElementById(cssCode + i).parentNode.style.cssText;
                    oldcss+="line-height:"+maxHeight+"px;";
                    document.getElementById(cssCode + i).parentNode.style.cssText=oldcss;
                }
            }
        }
        function _delelement(obj) {
            if (obj.length > 0) {
                for (var i = 0; i < obj.length; i++) {
                    obj[i].parentNode.removeChild(obj[i]);
                }
            }
        }
    }
})();
/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
 创建人   : MonaXia
 创建时间 : 2016-12-9
 说明     : 公用的图片预览页面 指定图片src
*********************************************************/
(function () {
    'use strict';
    xrmApp.controller("ImagePreviewer3Controller", ['$scope', '$stateParams', 'rt', '$timeout', '$rootScope', ImagePreviewer3Controller]);
    function ImagePreviewer3Controller($scope, $stateParams, rt, $timeout, $rootScope) {
        $scope.previewImageSrc = $scope.imgsrc;
    }
})();
/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/6/20
 说明     : 拜访选择客户，基于地图+原始lookup
 *********************************************************/


(function () {
    'use strict';
    xrmApp.controller("accountLookupAndMapController", ['$scope', 'rt','$compile', accountLookupAndMapController]);

    function accountLookupAndMapController($scope, rt,$compile) {
        $scope.chooseViewTypeValue=1;
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();

        //定义百度地图的地图对象
        var _map;
        //百度地图的缩放级别，大多数情况下使用14
        var _mapScale = 14;
        //显示百度地图的div的id
        var _mapDivId = "addressMap";


        _init();
        _init2();

        function _init() {
            $scope.vm = {};
            $scope.qv={};
            $scope.qv.queryValue = "";
            $scope.isLoadMore = false;
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.selectData = _selectData;
            $scope.removeValue = _removeValue;

            setTimeout(function(){
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                if(rt.isNull($scope.paramslist)){
                    $scope.paramslist = {};
                }
                _loadData(function(data){
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            },0);
        }

        function _init2() {
            $scope.accountList = [];
            $scope.accountNames = [];
            _locateAndLoadAccountList();
        }

        /**
         * 获取当前位置
         */
        function _locateAndLoadAccountList() {
            rt.getGeolocation(function (position) {
                if (position === null) {
                    return;
                }
                _map = new BMap.Map(_mapDivId);
                _map.centerAndZoom(new BMap.Point(position.longitude, position.latitude), _mapScale);
                var zoomControl = new BMap.ZoomControl();
                _map.addControl(zoomControl);//添加缩放控件
                var scaleControl = new BMap.ScaleControl();
                _map.addControl(scaleControl);//添加比例尺控件

                // 创建控件实例
                var myZoomCtrl = new ZoomControl();
                // 添加到地图当中
                _map.addControl(myZoomCtrl);

                //创建当前位置的点
                var marker = new BMap.Marker(new BMap.Point(position.longitude, position.latitude));
                //添加到地图中
                _map.addOverlay(marker);
                _loadAccountList(position);
            });
        }

        /**
         * 根据点获取一定范围内的客户
         * @param position
         * @private
         */
        function _loadAccountList(position) {
            _getAccountList(position.longitude, position.latitude)
                .success(function (data) {
                    rt.hideLoadingToast();
                    $scope.accountList = data;

                    if (data === null) {
                        return;
                    }
                    _addPoint(data);
                })
                .error(function (error) {
                    rt.hideLoadingToast();
                    rt.showErrorToast(error);
                });
        }

        /**
         * 指定范围内的客户信息
         * @param longitude
         * @param latitude
         * @returns {*}
         * @private
         */
        function _getAccountList(longitude, latitude) {
            var apiUrl = "api/Account/GetNearestAccount?longitude=" + longitude + "&latitude=" + latitude+"&moduleType="+$scope.lookupParams.accountType;
            return rt.get(apiUrl);
        }

        /**
         * 地图上添加点并显示
         * @param points
         * @private
         */
        function _addPoint(points) {
            _map.clearOverlays();
            var myIcon = new BMap.Icon("asset/img/bluemark.png", new BMap.Size(32, 45), {anchor: new BMap.Size(32, 45)});
            for (var i = 0; i < points.length; i++) {
                //构造地图显示的点
                var marker = new BMap.Marker(new BMap.Point(points[i].longitude, points[i].latitude), {icon: myIcon});
                _map.addOverlay(marker);
                setInfoWindow(marker, points[i]);
            }
        }


        /**
         * 设置标注的信息窗口
         * @param marker
         * @param title
         * @param address
         */
        function setInfoWindow(marker, point) {
            var content = '<div>';
            for (var i = 0; i < $scope.accountList.length; i++) {
                if ($scope.accountList[i].longitude === point.longitude &&
                    $scope.accountList[i].latitude === point.latitude) {
                    content +='<input ng-click="detailClick(' + i + ')" type="radio" name="hotel"/>'+ $scope.accountList[i].name + '<br/>';
                }
            }
            content += '</div>';
            _setInfo(marker, content);
        }

        function _setInfo(marker, content) {
            var compiled = $compile(content)($scope);
            var infoWindow = new BMap.InfoWindow(compiled[0], null);
            infoWindow.addEventListener("clickclose", function (e) {
                infoWindow.hide();
            });
            marker.addEventListener("click", function (e) {
                this.openInfoWindow(infoWindow);
            });
        }

        /**
         * 跳转客户拜访
         * @private
         */
        $scope.detailClick =function(index) {
            var d={id:$scope.accountList[index].Id,name:$scope.accountList[index].name};
            document.activeElement.checked = true;
            $scope.closeDialog();
            if (rt.isFunction($scope.callback) && !rt.isNull(d)) {
                $scope.callback(d);
            }
        }

        // 定义一个控件类，即function
        //定义一个刷新位置的控件
        function ZoomControl() {
            // 设置默认停靠位置和偏移量
            this.defaultAnchor = BMAP_ANCHOR_BOTTOM_RIGHT;
            this.defaultOffset = new BMap.Size(9, 160);
        }

        // 通过JavaScript的prototype属性继承于BMap.Control
        ZoomControl.prototype = new BMap.Control();

        // 自定义控件必须实现initialize方法，并且将控件的DOM元素返回
        // 在本方法中创建个div元素作为控件的容器，并将其添加到地图容器中
        ZoomControl.prototype.initialize = function (map) {
            // 创建一个DOM元素
            var div = document.createElement("div");
            // 添加文字说明
            div.innerHTML = '<img  style="width: 35px;height: 35px;" src="././asset/img/map_refresh.png" />';
            // 设置样式
            div.style.backgroundColor = "white";
            div.style.height = "35px";
            div.style.width = "35px";
            // 绑定事件，点击一次放大两级
            div.onclick = function (e) {
                rt.showLoadingToast("正在加载数据...");
                var newCenterPoint = _map.getCenter();

                _map = new BMap.Map(_mapDivId);
                _map.centerAndZoom(new BMap.Point(newCenterPoint.lng, newCenterPoint.lat), _mapScale);
                var zoomControl = new BMap.ZoomControl();
                _map.addControl(zoomControl);//添加缩放控件
                var scaleControl = new BMap.ScaleControl();
                _map.addControl(scaleControl);//添加比例尺控件

                // 创建控件实例
                var myZoomCtrl = new ZoomControl();
                // 添加到地图当中
                _map.addControl(myZoomCtrl);

                //创建当前位置的点
                var marker = new BMap.Marker(new BMap.Point(newCenterPoint.lng, newCenterPoint.lat));
                //添加到地图中
                _map.addOverlay(marker);

                var position = {};
                position.longitude = newCenterPoint.lng;
                position.latitude = newCenterPoint.lat;
                _loadAccountList(position);
            };
            // 添加DOM元素到地图中
            map.getContainer().appendChild(div);
            // 将DOM元素返回
            return div;
        };


        function _selectData(u){
            $scope.closeDialog();
            if(rt.isFunction($scope.callback) && !rt.isNull(u))
            {$scope.callback(u);}
        }
        function _removeValue(){
            $scope.closeDialog();
            $scope.callback({});
        }

        function _loadData(cb) {
            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            if($scope.isFiltered) {
                rt.filteredQueryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        rt.hideLoadingToast();
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if(cb !== undefined){
                            cb(data);
                        }
                    },
                    function (msg) {
                        if(cb !== undefined){
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            }else {
                rt.queryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        rt.hideLoadingToast();
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if(cb !== undefined){
                            cb(data);
                        }
                    },
                    function (msg) {
                        if(cb !== undefined){
                            cb();
                        }
                        rt.hideLoadingToast();
                        rt.showErrorToast(msg);
                    });
            }
        }

        function _viewRefresh() {
            _pageIndex = 1;
            _loadData(function(data){
                $scope.vm = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _loadMoreClick() {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function(data){
                if(!rt.isNull(data)){
                    if(!rt.isNull($scope.vm.DataList)){
                        $scope.vm.DataList.push.apply($scope.vm.DataList,data.DataList);
                    }else {
                        $scope.vm = data;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        function _searchClick() {
            _pageIndex = 1;
            _loadData(function(data){
                $scope.vm = data;
            });
        }

        $scope.chooseViewType=function(viewType){
            $scope.chooseViewTypeValue = viewType;
            if (viewType == 1) {
                _pageIndex = 1;
                _init();
            } else {
               _init2();
            }
        };
    }
})();
/********************************************************
Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
创建人   : ludwig Dong
创建时间 : 2016/09/01
说明     : 客户筛选 带我负责的lookup
*********************************************************/

(function () {
    'use strict';
    xrmApp.controller("accountLookupAndOwner2Controller", ['$ionicPopover', '$scope', '$state', 'rt', accountLookupAndOwner2Controller]);

    function accountLookupAndOwner2Controller($ionicPopover, $scope, $state, rt) {
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();

        _init();

        function _init() {
            $scope.vm = {};
            $scope.qv = {};
            $scope.qv.queryValue = "";
            $scope.isLoadMore = false;
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.selectData = _selectData;
            $scope.removeValue = _removeValue;

            setTimeout(function () {
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                $scope.accClass = $scope.lookupParams.accClass;
                $scope.initType = $scope.lookupParams.initType;
                if (rt.isNull($scope.accClass)) {
                    $scope.accClass = 0;
                }
                if (rt.isNull($scope.paramslist)) {
                    $scope.paramslist = {};
                }
                $scope.accType = [{ id: 2, name: "所有的客户" }];
                if (rt.isNull($scope.initType)) {
                    $scope.initType = 1;
                }
                _chooseViewTitleClick($scope.initType);
                _loadData(function (data) {
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            }, 0);
        }

        function _selectData(u) {
            $scope.closeDialog();
            if (rt.isFunction($scope.callback) && !rt.isNull(u))
            { $scope.callback(u); }
        }
        function _removeValue() {
            $scope.closeDialog();
            $scope.callback({});
        }

        function _loadData(cb) {
            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            var url = "api/BusinessAccount/GetOwnerAccountList?"
                + "accType=" + $scope.selectedaccType.id
                + "&accClass=" + $scope.accClass
                + "&queryValue=" + $scope.paramslist["@queryValue"]
                + "&pageSize=" + _pageSize
                + "&pageIndex=" + _pageIndex;
            rt.get(url, true).then(function (resp) {
                rt.hideLoadingToast();
                $scope.isLoadMore = resp.data.DataList.length >= _pageSize;
                if (cb !== undefined) {
                    cb(resp.data);
                }
            }).catch(function (error) {
                if (cb !== undefined) {
                    cb();
                }
                rt.hideLoadingToast();
                rt.showErrorToast(msg);
            });
        }

        function _viewRefresh() {
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _loadMoreClick() {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function (data) {
                if (!rt.isNull(data)) {
                    if (!rt.isNull($scope.vm.DataList)) {
                        $scope.vm.DataList.push.apply($scope.vm.DataList, data.DataList);
                    } else {
                        $scope.vm = data;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        function _searchClick() {
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;
            });
        }

        var _popoverchooseViewsTemplate =
            '<ion-popover-view style="height:{{2 * 44 + 6}}px;">' +
            '    <ion-content style="height:{{2 * 44}}px;"> ' +
            '        <ion-list> ' +
            '            <ion-item ng-repeat="v in accType"style="text-align:center;" ng-click="chooseViewTitleClick($index)"> ' +
            '                <span class="positive" >{{v.name}}</span> ' +
            '                <i class="ion ion-android-done positive" ng-show="selectedaccType.name == v.name"></i> ' +
            '            </ion-item> ' +
            '        </ion-list> ' +
            '    </ion-content> ' +
            '</ion-popover-view>';
        $scope.popoverchooseViews = $ionicPopover.fromTemplate(_popoverchooseViewsTemplate, {
            scope: $scope
        });

        $scope.chooseViewTitle = function ($event) {
            $scope.popoverchooseViews.show($event);
        };

        $scope.chooseViewTitleClick = function (index) {
            _chooseViewTitleClick(index)

        };
        function _chooseViewTitleClick(index) {
            $scope.selectedaccType = $scope.accType[index];
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
            $scope.popoverchooseViews.hide();
        }
    }
})();



/********************************************************
Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
创建人   : ludwig Dong
创建时间 : 2016/09/01
说明     : 客户筛选 带我负责的lookup
*********************************************************/

(function () {
    'use strict';
    xrmApp.controller("accountLookupAndOwnerController", ['$ionicPopover', '$scope', '$state', 'rt', accountLookupAndOwnerController]);

    function accountLookupAndOwnerController($ionicPopover, $scope, $state, rt) {
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();

        _init();

        function _init() {
            $scope.vm = {};
            $scope.qv = {};
            $scope.qv.queryValue = "";
            $scope.isLoadMore = false;
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.selectData = _selectData;
            $scope.removeValue = _removeValue;

            setTimeout(function () {
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                $scope.accClass = $scope.lookupParams.accClass;
                $scope.initType = $scope.lookupParams.initType;
                if (rt.isNull($scope.accClass)) {
                    $scope.accClass = 0;
                }
                if (rt.isNull($scope.paramslist)) {
                    $scope.paramslist = {};
                }
                $scope.accType = [{
                    id: 1, name: "我的客户"
                },
                    { id: 2, name: "所有的客户" }
                ];
                if (rt.isNull($scope.initType)) {
                    $scope.initType = 1;
                }
                _chooseViewTitleClick($scope.initType);
                _loadData(function (data) {
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            }, 0);
        }

        function _selectData(u) {
            $scope.closeDialog();
            if (rt.isFunction($scope.callback) && !rt.isNull(u))
            { $scope.callback(u); }
        }
        function _removeValue() {
            $scope.closeDialog();
            $scope.callback({});
        }

        function _loadData(cb) {
            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            var url = "api/BusinessAccount/GetOwnerAccountList?"
                + "accType=" + $scope.selectedaccType.id
                + "&accClass=" + $scope.accClass
                + "&queryValue=" + $scope.paramslist["@queryValue"]
                + "&pageSize=" + _pageSize
                + "&pageIndex=" + _pageIndex;
            rt.get(url, true).then(function (resp) {
                rt.hideLoadingToast();
                $scope.isLoadMore = resp.data.DataList.length >= _pageSize;
                if (cb !== undefined) {
                    cb(resp.data);
                }
            }).catch(function (error) {
                if (cb !== undefined) {
                    cb();
                }
                rt.hideLoadingToast();
                rt.showErrorToast(msg);
            });
        }

        function _viewRefresh() {
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _loadMoreClick() {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function (data) {
                if (!rt.isNull(data)) {
                    if (!rt.isNull($scope.vm.DataList)) {
                        $scope.vm.DataList.push.apply($scope.vm.DataList, data.DataList);
                    } else {
                        $scope.vm = data;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        function _searchClick() {
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;
            });
        }

        var _popoverchooseViewsTemplate =
            '<ion-popover-view style="height:{{2 * 44 + 6}}px;">' +
            '    <ion-content style="height:{{2 * 44}}px;"> ' +
            '        <ion-list> ' +
            '            <ion-item ng-repeat="v in accType"style="text-align:center;" ng-click="chooseViewTitleClick($index)"> ' +
            '                <span class="positive" >{{v.name}}</span> ' +
            '                <i class="ion ion-android-done positive" ng-show="selectedaccType.name == v.name"></i> ' +
            '            </ion-item> ' +
            '        </ion-list> ' +
            '    </ion-content> ' +
            '</ion-popover-view>';
        $scope.popoverchooseViews = $ionicPopover.fromTemplate(_popoverchooseViewsTemplate, {
            scope: $scope
        });

        $scope.chooseViewTitle = function ($event) {
            $scope.popoverchooseViews.show($event);
        };

        $scope.chooseViewTitleClick = function (index) {
            _chooseViewTitleClick(index)

        };
        function _chooseViewTitleClick(index) {
            $scope.selectedaccType = $scope.accType[index];
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
            $scope.popoverchooseViews.hide();
        }
    }
})();



/*global angular:false */
/*global _:false */
/*global xrmApp:false */
/*global UITaskView:false */

(function () {
    'use strict';
    xrmApp.controller("buMultiLookupController", ['$scope','$state', 'rt', buMultiLookupController]);

    function buMultiLookupController($scope,$state, rt) {
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();
        
        _init();

        function _init() {
            
            $scope.qv={};
            $scope.qv.queryValue = "";
            $scope.qv.selectedBu = {};
            $scope.qv.selectedBidDepart = {};
            $scope.qv.selectedBusinessUnits = {};
            
            $scope.vm = {};
            $scope.isLoadMore = false;
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.selectData = _selectData;
            $scope.OkClick = _okClick;

            setTimeout(function(){
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                if(rt.isNull($scope.paramslist)){
                    $scope.paramslist = {};
                }
                _loadData(function(data){
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            },0);
        }

        function _selectData(u){
            if(rt.isNull($scope.qv.selectedBu) || rt.isNull($scope.qv.selectedBu.id)){
                $scope.qv.selectedBu = u;
                
                $scope.getDataName = "TblBusinessUnit.ChildBusinessUnitId";
                $scope.paramslist = {'@ParentBusinessUnitId':u.id,'@queryValue':''};
                 _loadData(function(data){
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
                return;
            }
            
            if(rt.isNull($scope.qv.selectedBidDepart) || rt.isNull($scope.qv.selectedBidDepart.id)){
                $scope.qv.selectedBidDepart = u;
                
                $scope.getDataName = "TblBusinessUnit.ChildBusinessUnitId";
                $scope.paramslist = {'@ParentBusinessUnitId':u.id,'@queryValue':''};
                 _loadData(function(data){
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
                return;
            }
        }
        function _okClick(){
            $scope.qv.selectedBusinessUnits = [];
            for(var i = 0,n = $scope.vm.DataList.length;i < n;i++){
                if($scope.vm.DataList[i].checked){
                    $scope.qv.selectedBusinessUnits.push($scope.vm.DataList[i]);
                }
            }
            if(rt.isFunction($scope.callback) && !rt.isNull($scope.qv.selectedBusinessUnits) && $scope.qv.selectedBusinessUnits.length > 0){
                $scope.closeDialog();
                $scope.callback($scope.qv.selectedBusinessUnits);
            }
        }

        function _loadData(cb) {
            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            if($scope.isFiltered) {
                rt.filteredQueryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        rt.hideLoadingToast();
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if(cb !== undefined){
                            cb(data);
                        }
                    },
                    function (msg) {
                        if(cb !== undefined){
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            }else {
                rt.queryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        rt.hideLoadingToast();
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if(cb !== undefined){
                            cb(data);
                        }
                    },
                    function (msg) {
                        if(cb !== undefined){
                            cb();
                        }
                        rt.hideLoadingToast();
                        rt.showErrorToast(msg);
                    });
            }
        }

        function _viewRefresh() {
            _pageIndex = 1;
            _loadData(function(data){
                $scope.vm = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _loadMoreClick() {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function(data){
                if(!rt.isNull(data)){
                    if(!rt.isNull($scope.vm.DataList)){
                        $scope.vm.DataList.push.apply($scope.vm.DataList,data.DataList);
                    }else {
                        $scope.vm = data;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        function _searchClick() {
            _pageIndex = 1;
            _loadData(function(data){
                $scope.vm = data;
            });
        }
    }
})();



/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : ludwig Dong    
 创建时间 : 2016/08/31
 说明     : 业务部门阶段性筛选 （暂时）报表专用
 *********************************************************/

(function () {
    'use strict';
    xrmApp.controller("buReportLookup2Controller", ['$scope', '$state', 'rt', buReportLookup2Controller]);

    function buReportLookup2Controller($scope, $state, rt) {
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();

        _init();

        function _init() {

            $scope.qv = {};
            $scope.qv.queryValue = "";
            $scope.qv.selectedBu = {};
            $scope.qv.selectedBidDepart = {};
            $scope.qv.selectedBusinessUnits = {};

            $scope.vm = {};
            $scope.isLoadMore = false;
            $scope.isselectAll = {};
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.selectData = _selectData;
            $scope.selectTab = _selectTab;
            $scope.singleselect = _singleselect;
            $scope.OkClick = _okClick;
            $scope.selBu = true;
            $scope.selDep = false;
            $scope.buList = { DataList: [] };
            $scope.depList = { DataList: [] };

            $scope.buText = '请选择';
            $scope.depText = '请选择';
            setTimeout(function () {
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                $scope.isMultiple = !!$scope.lookupParams.isMultiple;
                if (rt.isNull($scope.paramslist)) {
                    $scope.paramslist = {};
                }
                _loadData(function (data) {
                    $scope.buList = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            }, 0);
        }

        function _selectTab(index) {
            switch (index) {
                case 0:
                    $scope.selBu = true;
                    $scope.selDep = false;
                    $scope.selBusinessUnit = false;
                    break;
                case 1:
                    $scope.selBu = false;
                    $scope.selDep = true;
                    $scope.selBusinessUnit = false;
                    break;
          /*      case 2:
                    $scope.selBu = false;
                    $scope.selDep = false;
                    $scope.selBusinessUnit = true;
                    break;*/
            }
        }
        function _singleselect(v) {
            if (!$scope.isMultiple) {
                var that = $scope.businessUnitList.DataList;
                var model = v;
                angular.forEach(that, function (v) {
                    if (v.id != model.id) {
                        v.checked = false;
                    }
                });
            }
        }

        $scope.selectAll = function () {
            var that = $scope.businessUnitList.DataList;
            angular.forEach(that, function (v) {
                if ($scope.isselectAll.checked) {
                    v.checked = true;
                } else {
                    v.checked = false;
                }
            });
        };

        function _selectData(u, buType) {
            if (buType == 1) {
                _revertCode(buType);
                $scope.qv.selectedBu = u;
                $scope.buText = u.name;
                $scope.selDep = true;
                $scope.selBu = false;
                $scope.isselectAll.checked = false;
                $scope.getDataName = "TblBusinessUnit.ChildBusinessUnitIdWithType";
                $scope.paramslist = { '@ParentBusinessUnitId': u.id, '@queryValue': '', '@businesstype': 20 };
                _loadData(function (data) {
                    $scope.depList = data;
                    $scope.$broadcast('scroll.refreshComplete');
                }, false);
                return;
            }

            if (buType == 2) {
                _revertCode(buType);
                $scope.qv.selectedBidDepart = u;
                _okClick();
            }
        }
        function _okClick() {
            if (rt.isNullOrEmptyString( $scope.qv.selectedBidDepart)) {
                $scope.closeDialog();
                $scope.callback ($scope.qv.selectedBidDepart);
            }
        }

        function _loadData(cb, isBusinessUnit, buType) {
            _selectSearch(buType);
            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            if (isBusinessUnit) {
                rt.filteredQueryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        rt.hideLoadingToast();
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function (msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            } else {
                rt.queryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        rt.hideLoadingToast();
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function (msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.hideLoadingToast();
                        rt.showErrorToast(msg);
                    });
            }
        }

        function _viewRefresh(buType) {
            _pageIndex = 1;
            _loadData(function (data) {
                switch (buType) {
                    case 1: $scope.buList = data; break;
                    case 2: $scope.depList = data; break;
                    case 3: $scope.businessUnitList = data; break;
                }
                $scope.$broadcast('scroll.refreshComplete');
            }, buType == 3 ? true : false, buType);
        }

        function _loadMoreClick(buType) {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function (data) {
                if (!rt.isNull(data)) {
                    if (!rt.isNull($scope.businessUnitList.DataList)) {
                        $scope.businessUnitList.DataList.push.apply($scope.businessUnitList.DataList, data.DataList);
                    } else {
                        $scope.businessUnitList.DataList = data;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }, buType == 3 ? true : false);
        }

        function _selectSearch(buType) {
            switch (buType) {
                case 1: $scope.paramslist = {}; $scope.getDataName = 'TblBusinessUnit.BuidBusinessUnitId'; break;
                case 2: $scope.paramslist["@ParentBusinessUnitId"] = $scope.qv.selectedBu.id;
                    $scope.getDataName = "TblBusinessUnit.ChildBusinessUnitId"; break;
                case 3: $scope.paramslist["@ParentBusinessUnitId"] = $scope.qv.selectedBidDepart.id;
                    $scope.getDataName = "TblBusinessUnit.ChildBusinessUnitId"; break;
            }
        }

        function _revertCode(buType) {
            switch (buType) {
                case 1:
                    $scope.depText = '请选择';
                    $scope.depList = { DataList: [] };
                    $scope.businessUnitList = { DataList: [] };
                    ; break;
           /*     case 2:
                    $scope.businessUnitList = { DataList: [] };
                    ; break;*/
            }
            _pageIndex = 1;
        }

        function _searchClick() {
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;
            });
        }
    }
})();



/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : ludwig Dong    
 创建时间 : 2016/08/31
 说明     : 业务部门阶段性筛选 （暂时）报表专用
 *********************************************************/

(function () {
    'use strict';
    xrmApp.controller("buReportLookupController", ['$scope', '$state', 'rt', buReportLookupController]);

    function buReportLookupController($scope, $state, rt) {
        var _pageIndex = 1;
        var _pageSize = 5000;

        _init();

        function _init() {

            $scope.qv = {};
            $scope.qv.queryValue = "";
            $scope.qv.selectedBidDepart = {};
            $scope.qv.selectedBusinessUnits = {};

            $scope.vm = {};
            $scope.vm.isShow1 = false;
            $scope.isselectAll = [];
            $scope.selectData = _selectData;
            $scope.singleselect = _singleselect;
            $scope.showselecte = _showselecte;
            $scope.chooseTab = _chooseTab;
            $scope.OkClick = _okClick;
            $scope.depList = { DataList: [] };
            $scope.isshowList = [];//展开列表键值列表
            $scope.selshowKey = -1;//展开列表某一键值
            $scope.showKey = -1;//当前选中的键值
            $scope.bubodyList = [];
            $scope.itemActiveTarg = [];//标识选择了哪些业务线

            setTimeout(function () {
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                $scope.isMultiple = !!$scope.lookupParams.isMultiple;
                $scope.isFiltered = true;
                if (rt.isNull($scope.paramslist)) {
                    $scope.paramslist = {};
                }
                _loadData(function (data) {
                    $scope.depList = data;
                    _loadCheckedTarget();
                    $scope.$broadcast('scroll.refreshComplete');
                }, true);
            }, 0);
        }


        function _singleselect(v) {
            if (!$scope.isMultiple) {
                angular.forEach($scope.bubodyList[$scope.showKey].DataList, function (entity) {
                    if (entity.id != v.id) {
                        entity.checked = false;
                    }
                });
            }
        }

        $scope.selectAll = function () {
            var that = $scope.bubodyList[$scope.showKey].DataList;
            angular.forEach(that, function (v) {
                if ($scope.isselectAll[$scope.showKey].checked) {
                    v.checked = true;
                    $scope.itemActiveTarg[$scope.showKey] = true;
                } else {
                    v.checked = false;
                    $scope.itemActiveTarg[$scope.showKey] = false;
                }
            });
        };

        function _loadCheckedTarget() {
            if (!rt.isNull($scope.depList) && $scope.depList.DataList.length > 0) {
                var index = 0;
                angular.forEach($scope.depList.DataList, function (entity) {
                    $scope.isshowList[index] = false;
                    index++;
                });
            }
        }

        function _showselecte(v) {
            var havesel = false;
            angular.forEach($scope.bubodyList[$scope.showKey].DataList, function (entity) {
                if (entity.checked) {
                    havesel = true;
                }
            });
            if (havesel) {
                $scope.itemActiveTarg[$scope.showKey] = true;
            } else {
                $scope.itemActiveTarg[$scope.showKey] = false;
                $scope.isselectAll[$scope.showKey].checked = false;
            }
            if (!v.checked) {
                $scope.isselectAll[$scope.showKey].checked = false;
            }
        }

        function _chooseTab(index, v) {
            var eachindex = 0;
            angular.forEach($scope.isshowList, function (entity) {
                if (eachindex == index) {
                    entity ? $scope.isshowList[eachindex] = false : $scope.isshowList[eachindex] = true;
                } else {
                    $scope.isshowList[eachindex] = false;
                }
                eachindex++;
            });
            if ($scope.isshowList[index]) {
                if (rt.isNull($scope.bubodyList[index])) {
                    _selectData(v, index);
                }
            }
            $scope.showKey = index;
            // } else {
            //     $scope.businessUnitList = {};
            //     $scope.showKey = -1;
            //     $scope.selshowKey = -1;
            // }
        }

        function _selectData(u, index) {
            $scope.qv.selectedBidDepart = u;
            $scope.getDataName = "TblBusinessUnit.ChildBusinessUnitIdWithType";
            $scope.paramslist = { '@ParentBusinessUnitId': u.id, '@queryValue': '', '@businesstype': 10 };
            _loadData(function (data) {
                $scope.bubodyList[index] = data;
                $scope.$broadcast('scroll.refreshComplete');
            }, false);
        }
        function _okClick() {
            var that = $scope.bubodyList;
            $scope.qv.selectedBusinessUnits = [];

            angular.forEach(that, function (bulist) {
                angular.forEach(bulist.DataList, function (model) {
                    if (model.checked) {
                        $scope.qv.selectedBusinessUnits.push(model);
                    }
                })
            })
            if (rt.isFunction($scope.callback) && !rt.isNull($scope.qv.selectedBusinessUnits) && $scope.qv.selectedBusinessUnits.length > 0) {
                $scope.closeDialog();
                $scope.callback($scope.qv.selectedBusinessUnits);
            }
        }

        function _loadData(cb, isFirst) {
            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            if (isFirst) {
                var url = "api/TblBusinessUnit/GetBuIdDataForFiler";
                rt.get(url, true).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        rt.hideLoadingToast();
                        $scope.isLoadMore = resp.data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(resp.data);
                        }
                    }
                }).catch(function (error) {
                    if (cb !== undefined) {
                        cb();
                    }
                    rt.hideLoadingToast();
                    rt.showErrorToast(error);
                });
            } else {
                $scope.filteredQueryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        rt.hideLoadingToast();
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function (msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            }
        }

        $scope.filteredQueryPagingData = function (getDataName, paramsList, orderby, pageIndex, success, error) {
            rt.post("api/DataService/FilteredQuery", {
                GetDataName: getDataName,
                Paramslist: paramsList,
                Orderby: orderby,
                PageSize: _pageSize,
                PageIndex: pageIndex
            }).success(function (dataString) {
                var data = JSON.parse(decodeURIComponent(dataString));
                if (success) {
                    success(data);
                }
            }).error(function (msg) {
                if (error) {
                    error(msg);
                }
                else {
                    rt.showErrorToast(msg);
                }
            });
        };

    }
})();



/*global angular:false */
/*global _:false */
/*global xrmApp:false */
/*global UITaskView:false */

(function () {
    'use strict';
    xrmApp.controller("buSingleLookupController", ['$scope','$state', 'rt', buSingleLookupController]);

    function buSingleLookupController($scope,$state, rt) {
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();
        
        _init();

        function _init() {
            $scope.qv={};
            $scope.qv.queryValue = "";
            $scope.qv.selectedBu = {};
            $scope.qv.selectedBidDepart = {};
            $scope.qv.selectedBusinessUnit = {};
            
            $scope.vm = {};
            $scope.isLoadMore = false;
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.selectData = _selectData;
            $scope.removeValue = _removeValue;

            setTimeout(function(){
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                if(rt.isNull($scope.paramslist)){
                    $scope.paramslist = {};
                }
                _loadData(function(data){
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            },0);
        }

        function _selectData(u){
            if(rt.isNull($scope.qv.selectedBu) || rt.isNull($scope.qv.selectedBu.id)){
                $scope.qv.selectedBu = u;
                
                $scope.getDataName = "TblBusinessUnit.ChildBusinessUnitId";
                $scope.paramslist = {'@ParentBusinessUnitId':u.id,'@queryValue':''};
                 _loadData(function(data){
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
                return;
            }
            
            if(rt.isNull($scope.qv.selectedBidDepart) || rt.isNull($scope.qv.selectedBidDepart.id)){
                $scope.qv.selectedBidDepart = u;
                
                $scope.getDataName = "TblBusinessUnit.ChildBusinessUnitId";
                $scope.paramslist = {'@ParentBusinessUnitId':u.id,'@queryValue':''};
                 _loadData(function(data){
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
                return;
            }
            
            $scope.closeDialog();
            if(rt.isFunction($scope.callback) && !rt.isNull(u))
            {$scope.callback(u);}
        }
        function _removeValue(){
            $scope.closeDialog();
            $scope.callback({});
        }

        function _loadData(cb) {
            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            if($scope.isFiltered) {
                rt.filteredQueryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        rt.hideLoadingToast();
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if(cb !== undefined){
                            cb(data);
                        }
                    },
                    function (msg) {
                        if(cb !== undefined){
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            }else {
                rt.queryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        rt.hideLoadingToast();
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if(cb !== undefined){
                            cb(data);
                        }
                    },
                    function (msg) {
                        if(cb !== undefined){
                            cb();
                        }
                        rt.hideLoadingToast();
                        rt.showErrorToast(msg);
                    });
            }
        }

        function _viewRefresh() {
            _pageIndex = 1;
            _loadData(function(data){
                $scope.vm = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _loadMoreClick() {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function(data){
                if(!rt.isNull(data)){
                    if(!rt.isNull($scope.vm.DataList)){
                        $scope.vm.DataList.push.apply($scope.vm.DataList,data.DataList);
                    }else {
                        $scope.vm = data;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        function _searchClick() {
            _pageIndex = 1;
            _loadData(function(data){
                $scope.vm = data;
            });
        }
    }
})();



/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   :
 创建时间 : 2016/4/1
 说明     :可滑动预览照片
 *********************************************************/
(function () {
    'use strict';
    xrmApp.controller("cascadePickerController", ['$scope', '$ionicSlideBoxDelegate', 'rt', '$timeout', cascadePickerController]);

    function cascadePickerController($scope, $ionicSlideBoxDelegate, rt, $timeout) {

        function _init() {
            $scope.cascadePicker = $scope.cascadePicker || {};

            $scope.cascadePicker.objects = [];
            $scope.cascadePicker.isOK = 0;
            $scope.cascadePicker.slideHasChanged = _slideHasChanged;

            $scope.cascadePicker.slideTo = _slideTo;
            $scope.cascadePicker.OkClick = _okClick;
            $scope.cascadePicker.pick = _pick;
            $scope.cascadePicker.dataProvider = [_getProvinceList, _getCityList, _getCountyList];
            _load();

        }

        var tmpObjects = [{
            dataSource: null
        }];

        function _load() {
            if (rt.isNull($scope.cascadePicker.dataProvider)) {
                return;
            }

            //如果没有选中值，则只需要加载第一项
            if (rt.isNull($scope.cascadePicker.selectedValue) || $scope.cascadePicker.selectedValue.length === 0) {
                $scope.cascadePicker.objects.push({
                    dataSource: null
                });
                $scope.cascadePicker.dataProvider[0]().then(function (resp) {
                    $scope.cascadePicker.objects[0].dataSource = resp.data;
                    $scope.slideIndex = 0;
                });
                return;
            }

            var tmpObjects = [{
                dataSource: null
            }];

            function ___load(idx, value) {
                $scope.cascadePicker.dataProvider[idx](value)
                    .then(function (resp) {
                        tmpObjects[idx].dataSource = resp.data;

                        var selectedValue = $scope.cascadePicker.selectedValue[idx].Id;
                        var selectedItem = _.find(resp.data, {"Id": selectedValue})

                        if (!rt.isNull(selectedItem)) {
                            tmpObjects[idx].selectedValue = selectedItem;
                        }

                        if (rt.isNull(selectedItem) || idx >= $scope.cascadePicker.dataProvider.length - 1) {
                            $scope.cascadePicker.objects = tmpObjects;

                            $ionicSlideBoxDelegate.update();

                            $scope.cascadePicker.slideIndex = idx;
                        } else {
                            tmpObjects.push({
                                dataSource: null
                            });
                            ___load(idx + 1, selectedItem.Id);
                        }
                    });
            }

            ___load(0);
        }

        function _okClick(index, obj) {
            if (index == 1) {
                var result = [];
                $scope.cascadePicker.objects.map(function (obj) {
                    if (!rt.isNull(obj.selectedValue)) {
                        result.push({
                            "Id": obj.selectedValue.Id,
                            "name": obj.selectedValue.name,
                            "code": obj.selectedValue.code
                        });
                    } else {
                        result.push({"Id": '', "name": '', "code": ''});
                    }
                });
                $scope.cascadePicker.close();
                $scope.cascadePicker.success(result);
                $scope.cascadePicker = null;
                delete $scope.cascadePicker;
                return;
            }
        }

        function _pick(index, obj) {
            $scope.obj = obj;
            $scope.index = index;
            if (index + 1 >= $scope.cascadePicker.dataProvider.length) {
                $scope.cascadePicker.objects[index].selectedValue = obj;

                var result = [];
                $scope.cascadePicker.objects.map(function (obj) {
                    result.push({
                        "Id": obj.selectedValue.Id,
                        "name": obj.selectedValue.name,
                        "code": obj.selectedValue.code
                    });
                });

                $scope.cascadePicker.close();
                $scope.cascadePicker.success(result);
                $scope.cascadePicker = null;
                delete $scope.cascadePicker;
                return;
            }

            if (obj === $scope.cascadePicker.objects[index].selectedValue) {
                _slideTo(index + 1);
                return;
            }

            $scope.cascadePicker.objects[index].selectedValue = obj;

            while ($scope.cascadePicker.objects.length > index + 1) {
                $scope.cascadePicker.objects.pop();
            }

            if ($scope.cascadePicker.objects.length === index + 1 || $scope.cascadePicker.objects[index + 1].dataSource === null || $scope.cascadePicker.objects[index + 1].dataSource === undefined) {
                $scope.cascadePicker.objects.push({
                    dataSource: null
                });

                $scope.cascadePicker.dataProvider[index + 1](obj.Id)
                    .then(function (resp) {
                        $scope.cascadePicker.objects[index + 1].dataSource = resp.data;
                    });

                $ionicSlideBoxDelegate.update();
            }

            _slideTo(index + 1);
        }

        function _slideTo(index) {
            $timeout(function () {
                $ionicSlideBoxDelegate.slide(index);
            }, 0);
        }

        function _slideHasChanged(index) {
            $scope.cascadePicker.slideIndex = index;
        }

        _init();
        function _getProvinceList() {
            return rt.get("api/City/GetProvinceList");
        }

        function _getCityList(provinceId) {
            return rt.get("api/City/GetCityList?provinceid=" + provinceId);
        }

        function _getCountyList(cityId) {
            return rt.get("api/City/GetCountyList?cityid=" + cityId);
        }
    }

})();

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/9/22
 说明     : 医院拜访，医生lookup（包含代表负责的医生）
 *********************************************************/

(function () {
    'use strict';
    xrmApp.controller("contactDeptLookupController", ['$scope', '$state', 'rt', contactDeptLookupController]);

    function contactDeptLookupController($scope, $state, rt) {
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();
        _init();

        function _init() {
            $scope.vm = {};
            $scope.qv = {};
            $scope.qv.queryValue = "";
            $scope.isLoadMore = false;
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.selectData = _selectData;
            $scope.removeValue = _removeValue;
            $scope.getAvatarColor = _getAvatarColor;
            $scope.getAvatarName = _getAvatarName;

            setTimeout(function () {
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                $scope.departmentid = $scope.lookupParams.departmentid;
                if (rt.isNull($scope.paramslist)) {
                    $scope.paramslist = {};
                }
                _loadData(function (data) {
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            }, 0);
        }

        function _selectData(u) {
            $scope.closeDialog();
            if (rt.isFunction($scope.callback) && !rt.isNull(u)) {
                $scope.callback(u);
            }
        }

        function _removeValue() {
            $scope.closeDialog();
            $scope.callback({});
        }

        function _loadData(cb, msg) {
            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;

            var url = "api/HospitalContact/GetDeptContactList" +
                "?queryValue=" + encodeURIComponent($scope.qv.queryValue) +
                "&departmentId=" + encodeURIComponent($scope.departmentid) +
                "&pageIndex=" + encodeURIComponent(_pageIndex) +
                "&pageSize=" + _pageSize;
            rt.get(url)
                .success(function (data) {
                    $scope.isLoadMore = data.length >= _pageSize;
                    if (cb !== undefined) {
                        cb(data);
                    }
                })
                .error(function (error) {
                    if (msg) {
                        msg();
                    }
                    rt.showErrorToast(error);
                });
        }

        function _viewRefresh() {
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _loadMoreClick() {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function (data) {
                if (!rt.isNull(data)) {
                    $scope.vm.push.apply($scope.vm, data);
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        function _searchClick() {
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;
            });
        }

        var _avatarColors = [
            "#2ec7c9", "#feb358", "#33bc98", "#b6a2de"
        ];

        function _getAvatarColor(index) {
            var i = index % 4;
            return _avatarColors[i];
        }

        function _getAvatarName(name) {
            if (rt.isNull(name)) {
                return "";
            }
            return name.length <= 2 ? name : name.substring(1, 3)
        }
    }
})();



/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : joe Song
 创建时间 : 2016-03-22
 说明     : 联系人lookup查询
 *********************************************************/

(function() {
    'use strict';
    xrmApp.controller("contactLookup2Controller", ['$scope', '$state', 'rt', contactLookup2Controller]);

    function contactLookup2Controller($scope, $state, rt) {
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();
        _init();

        function _init() {
            $scope.vm = {};
            $scope.qv = {};
            $scope.qv.queryValue = "";
            $scope.isLoadMore = false;
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.selectData = _selectData;
            $scope.removeValue = _removeValue;
            $scope.getAvatarColor =  _getAvatarColor;
            $scope.getAvatarName = _getAvatarName;
            
            setTimeout(function() {
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                if (rt.isNull($scope.paramslist)) {
                    $scope.paramslist = {};
                }
                _loadData(function(data) {
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            }, 0);
        }

        function _selectData(u) {
            $scope.closeDialog();
            if (rt.isFunction($scope.callback) && !rt.isNull(u))
            { $scope.callback(u); }
        }
        function _removeValue() {
            $scope.closeDialog();
            $scope.callback({});
        }

        function _loadData(cb) {
            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            if ($scope.isFiltered) {
                rt.filteredQueryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function(data) {
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function(msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            } else {
                rt.queryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function(data) {
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function(msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            }
        }

        function _viewRefresh() {
            _pageIndex = 1;
            _loadData(function(data) {
                $scope.vm = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _loadMoreClick() {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function(data) {
                if (!rt.isNull(data)) {
                    if (!rt.isNull($scope.vm.DataList)) {
                        $scope.vm.DataList.push.apply($scope.vm.DataList, data.DataList);
                    } else {
                        $scope.vm = data;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        function _searchClick() {
            _pageIndex = 1;
            _loadData(function(data) {
                $scope.vm = data;
            });
        }

        var _avatarColors = [
            "#2ec7c9", "#feb358", "#33bc98", "#b6a2de"
        ];

        function _getAvatarColor(index) {
            var i = index % 4;
            return _avatarColors[i];
        }

        function _getAvatarName(name) {
            if (rt.isNull(name)) {
                return "";
            }
            return name.length <= 2 ? name : name.substring(1, 3)
        }
    }
})();



/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : joe Song
 创建时间 : 2016-03-22
 说明     : 联系人lookup查询
 *********************************************************/

(function() {
    'use strict';
    xrmApp.controller("contactLookupController", ['$scope', '$state', 'rt', contactLookupController]);

    function contactLookupController($scope, $state, rt) {
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();
        _init();

        function _init() {
            $scope.vm = {};
            $scope.qv = {};
            $scope.qv.queryValue = "";
            $scope.isLoadMore = false;
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.selectData = _selectData;
            $scope.removeValue = _removeValue;
            $scope.getAvatarColor =  _getAvatarColor;
            $scope.getAvatarName = _getAvatarName;
            
            setTimeout(function() {
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                if (rt.isNull($scope.paramslist)) {
                    $scope.paramslist = {};
                }
                _loadData(function(data) {
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            }, 0);
        }

        function _selectData(u) {
            $scope.closeDialog();
            if (rt.isFunction($scope.callback) && !rt.isNull(u))
            { $scope.callback(u); }
        }
        function _removeValue() {
            $scope.closeDialog();
            $scope.callback({});
        }

        function _loadData(cb) {
            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            if ($scope.isFiltered) {
                rt.filteredQueryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function(data) {
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function(msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            } else {
                rt.queryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function(data) {
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function(msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            }
        }

        function _viewRefresh() {
            _pageIndex = 1;
            _loadData(function(data) {
                $scope.vm = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _loadMoreClick() {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function(data) {
                if (!rt.isNull(data)) {
                    if (!rt.isNull($scope.vm.DataList)) {
                        $scope.vm.DataList.push.apply($scope.vm.DataList, data.DataList);
                    } else {
                        $scope.vm = data;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        function _searchClick() {
            _pageIndex = 1;
            _loadData(function(data) {
                $scope.vm = data;
            });
        }

        var _avatarColors = [
            "#2ec7c9", "#feb358", "#33bc98", "#b6a2de"
        ];

        function _getAvatarColor(index) {
            var i = index % 4;
            return _avatarColors[i];
        }

        function _getAvatarName(name) {
            if (rt.isNull(name)) {
                return "";
            }
            return name.length <= 2 ? name : name.substring(1, 3)
        }
    }
})();



/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : ludwig Dong    
 创建时间 : 2016/09/8
 说明     : 根据医院-科室带出医生选择lookup
 *********************************************************/

(function () {
    'use strict';
    xrmApp.controller("doctorLookupController", ['$scope', '$state', 'rt', doctorLookupController]);

    function doctorLookupController($scope, $state, rt) {
        var _pageIndex = 1;//医院
        //var _pageIndex_dep = 1;//科室
        var _pageIndex_doc = 1;//医生
        var _pageSize = rt.getPaginationSize();

        _init();

        function _init() {
            $scope.qv = {};
            $scope.qv.queryValue = "";
            //$scope.qv.queryValue_dep = "";
            $scope.qv.queryValue_doc = "";
            $scope.qv.selectedhos = {};//选中的医院
            //$scope.qv.selecteddep = {};//选中的科室
            $scope.qv.selecteddoc = {};//选中的医生

            $scope.vm = {};
            $scope.isLoadMore = false;
            //$scope.isLoadMore_dep = false;
            $scope.isLoadMore_doc = false;
            $scope.isselectAll = {};
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.selectTab = _selectTab;
            $scope.tabIndex = 1;//切换TAB的索引
            $scope.OkClick = _okClick;
            $scope.accType = 1;//医院选择TAB默认我负责的
            $scope.choosehosTab = _choosehosTab;
            $scope.selectData = _selectData;

            $scope.hosText = '请选择';
            //$scope.depText = '请选择';
            $scope.DocText = '请选择';
            $scope.queryText = "输入客户名称快速搜索";
            $scope.selHos = true;
            //$scope.selDep = false;
            $scope.selDoc = false;
            setTimeout(function () {
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                $scope.isMultiple = !!$scope.lookupParams.isMultiple;
                if (rt.isNull($scope.paramslist)) {
                    $scope.paramslist = {};
                }
                _loadData(function (data) {
                    $scope.hoslist = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            }, 0);
        }

        function _selectTab(index) {
            $scope.tabIndex = index;
            switch (index) {
                case 1:
                    $scope.selHos = true;
                    //$scope.selDep = false;
                    $scope.selDoc = false;
                    $scope.queryText = "输入客户名称快速搜索";
                    break;
                // case 2:
                //     $scope.selHos = false;
                //     $scope.selDep = true;
                //     $scope.selDoc = false;
                //     $scope.queryText = "输入科室名字快速搜索";
                //     break;
                case 3:
                    $scope.selHos = false;
                    //$scope.selDep = false;
                    $scope.selDoc = true;
                    $scope.queryText = "输入联系人名字快速搜索";
                    break;
            }
        }
        function _singleselect(v) {
            if (!$scope.isMultiple) {
                var that = $scope.doctorlist.DataList;
                var model = v;
                angular.forEach(that, function (v) {
                    if (v.id != model.id) {
                        v.checked = false;
                    }
                });
            }
        }

        $scope.selectAll = function () {
            var that = $scope.doctorlist.DataList;
            angular.forEach(that, function (v) {
                if ($scope.isselectAll.checked) {
                    v.checked = true;
                } else {
                    v.checked = false;
                }
            });
        };

        function _choosehosTab(index) {
            $scope.accType = index;
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.hoslist = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _selectData(u, seType) {
            // if (seType == 1) {
            //     _revertCode(seType);
            //     $scope.qv.selectedhos = u;
            //     $scope.hosText = u.name;
            //     $scope.selDep = true;
            //     $scope.selHos = false;
            //     $scope.isselectAll.checked = false;
            //     $scope.tabIndex = 2;
            //     $scope.queryText = "输入科室名字快速搜索";
            //     $scope.getDataName = "Depart.GetDepart";
            //     $scope.paramslist = { '@accountid': u.Id, '@queryValue': '' };
            //     _loadData(function (data) {
            //         $scope.deplist = data;
            //         $scope.$broadcast('scroll.refreshComplete');
            //     }, false);
            //     return;
            // }
            if (seType == 1) {
                _revertCode(seType);
                $scope.qv.selectedhos = u;
                $scope.hosText = u.name;
                $scope.selHos = false;
                $scope.selDoc = true;
                $scope.tabIndex = 3;
                $scope.isselectAll.checked = false;
                $scope.queryText = "输入联系人名字快速搜索";
                $scope.getDataName = "Contact.GetContact";
                $scope.paramslist = { '@accountid': u.Id, '@queryValue': '' };
                _loadData(function (data) {
                    $scope.doctorlist = data;
                    $scope.$broadcast('scroll.refreshComplete');
                }, true);
                return;
            }

        }
        function _okClick() {
            var that = $scope.doctorlist.DataList;
            $scope.qv.selecteddoc = [];
            for (var i = 0, n = that.length; i < n; i++) {
                if (that[i].checked) {
                    $scope.qv.selecteddoc.push(that[i]);
                }
            }
            if (rt.isFunction($scope.callback) && !rt.isNull($scope.qv.selecteddoc) && $scope.qv.selecteddoc.length > 0) {
                $scope.closeDialog();
                $scope.callback($scope.qv.selecteddoc);
            }
        }

        function _loadData(cb) {
            rt.showLoadingToast("疯狂加载中...");
            if ($scope.selHos) {
                $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
                var url = "api/BusinessAccount/GetOwnerAccountList?"
                    + "accType=" + $scope.accType
                    + "&accClass=" + 0
                    + "&queryValue=" + $scope.paramslist["@queryValue"]
                    + "&pageSize=" + _pageSize
                    + "&pageIndex=" + _pageIndex;
                rt.get(url, true).then(function (resp) {
                    rt.hideLoadingToast();
                    $scope.isLoadMore = resp.data.DataList.length >= _pageSize;
                    if (cb !== undefined) {
                        cb(resp.data);
                    }
                }).catch(function (error) {
                    if (cb !== undefined) {
                        cb();
                    }
                    rt.hideLoadingToast();
                    rt.showErrorToast(msg);
                });

            } else {
                rt.filteredQueryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex_doc,
                    function (data) {
                        rt.hideLoadingToast();
                        $scope.isLoadMore_doc = data.DataList.length >= _pageSize;

                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function (msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.hideLoadingToast();
                        rt.showErrorToast(msg);
                    });
            }
        }

        function _viewRefresh(buType) {
            _whichOneNow(1);
            _whichOneNow(4);
            _loadData(function (data) {
                _whichOneNow(3, data);
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _loadMoreClick(buType) {
            var whichload;
            switch ($scope.tabIndex) {
                case 1: whichload = $scope.isLoadMore; break;
                case 2: whichload = $scope.isLoadMore_dep; break;
                case 3: whichload = $scope.isLoadMore_doc; break;
            }
            if (!whichload) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }
            _whichOneNow(2);
            _loadData(function (data) {
                if (!rt.isNull(data)) {
                    switch ($scope.tabIndex) {
                        case 1: if (!rt.isNull($scope.hoslist.DataList)) {
                            $scope.hoslist.DataList.push.apply($scope.hoslist.DataList, data.DataList);
                        } break;
                        case 2: if (!rt.isNull($scope.deplist.DataList)) {
                            $scope.deplist.DataList.push.apply($scope.deplist.DataList, data.DataList);
                        } break;
                        case 3: if (!rt.isNull($scope.doctorlist.DataList)) {
                            $scope.doctorlist.DataList.push.apply($scope.doctorlist.DataList, data.DataList);
                        } break;
                        default: _whichOneNow(3, data); break;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }


        function _revertCode(buType) {//切换一级二级显示数据复位
            switch (buType) {
                case 1:
                    $scope.depText = '请选择';
                    $scope.deplist = { DataList: [] };
                    $scope.doctorlist = { DataList: [] };
                    ; break;
                case 2:
                    $scope.doctorlist = { DataList: [] };
                    ; break;
            }
            _pageIndex = 1;
        }

        function _searchClick() {
            _whichOneNow(1);
            _whichOneNow(4);
            _loadData(function (data) {
                _whichOneNow(3, data);
            });
        }
        function _whichOneNow(addType, data) {//展现在页面上的是谁，addType：1 页码归位；      
            if (addType == 1) {               //2 下一页 3 是谁的数据 data:过来的数据
                switch ($scope.tabIndex) {    //4: 选择调用的GetDATA 方法名
                    case 1: _pageIndex = 1; break;
                    case 2: _pageIndex_dep = 1; break;
                    case 3: _pageIndex_doc = 1; break;
                }
            }
            if (addType == 2) {
                switch ($scope.tabIndex) {
                    case 1: _pageIndex++; break;
                    case 2: _pageIndex_dep++; break;
                    case 3: _pageIndex_doc++; break;
                }
            }
            if (addType == 3) {
                switch ($scope.tabIndex) {
                    case 1: $scope.hoslist = data; break;
                    case 2: $scope.deplist = data; break;
                    case 3: $scope.doctorlist = data; break;
                }
            }
            if (addType == 4) {
                switch ($scope.tabIndex) {
                    // case 2:
                    //     $scope.getDataName = "Depart.GetDepart";
                    //     $scope.paramslist = { '@accountid': $scope.qv.selectedhos.Id, '@queryValue': $scope.qv.queryValue_dep }; break;
                    case 3:
                        $scope.getDataName = "Contact.GetContact";
                        $scope.paramslist = { '@accountid': $scope.qv.selectedhos.Id, '@queryValue': $scope.qv.queryValue_doc }; break;
                }
            }
        }
    }
})();



/// <reference path="AccountModule.js" />
/*global xrmApp:false */
/*global UIQueryTitleData:false */
/*global UserModel:false */
(function () {
    'use strict';
    function LookupUserController($scope, $state, LookupService, $ionicActionSheet,rtUtils) {
        var _pageIndex = 1;
        var _pageSize = 1;

        function _init() {
            $scope.vm = {};
            $scope.vm.queryValue = "";
            $scope.vm.viewList = [];
            $scope.vm.selectedViewId = "";
            $scope.vm.selectedViewName = "";

            $scope.vm.viewRowDataList = [];

            $scope.selectViewMenu = _selectViewMenu;
            $scope.loadMoreData = _loadMoreData;
            $scope.search = _search;
            $scope.selectData = _selectData;
            $scope.removeValue = _removeValue;
            _loadViewList();
        }

        function _loadViewList() {
            var data =[];
            var queryTitle1 = new UIQueryTitleData();
            queryTitle1.SavedQueryId = "1";
            queryTitle1.ViewName = "用户查找视图";
            data.push(queryTitle1);
            var queryTitle2 = new UIQueryTitleData();
            queryTitle2.SavedQueryId = "2";
            queryTitle2.ViewName = "用户查找视图2";
            data.push(queryTitle2);
            $scope.vm.viewList = data;
            $scope.vm.selectedViewId = data[0].SavedQueryId;
            $scope.vm.selectedViewName = data[0].ViewName;

            rtUtils.showLoadingToast('正在加载数据...');
            _pageIndex = 1;

            _loadViewData(function () {
                rtUtils.hideLoadingToast();
            });
           /* LookupService.getViewList('SystemUser')
                .error(function (data) { alert(data); })
                .success(function (data) {
                if (data === undefined || data === null || data.length === 0)
                { return;}


                $scope.vm.viewList = data;
                $scope.vm.selectedViewId = data[0].SavedQueryId;
                $scope.vm.selectedViewName = data[0].ViewName;

                rtUtils.showLoadingToast('正在加载数据...');
                _pageIndex = 1;

                _loadViewData(function () {
                    rtUtils.hideLoadingToast();
                });
            });*/

        }

        function _loadViewData(cb) {
            if ($scope.vm.selectedViewId === ""){
                if(rtUtils.isFunction(cb))
                {
                    cb();
                }


                return;
            }


            if(_pageIndex === 1)
            {   $scope.vm.viewRowDataList = [];}

            var data = [];
            var user1 = new UserModel();
            user1.userCode = "001";
            user1.userName = "admin";
            data.push(user1);
            var user2 = new UserModel();
            user2.userCode = "002";
            user2.userName = "administrator";
            data.push(user2);
            $scope.vm.viewRowDataList =data;
            if(rtUtils.isFunction(cb))
            {   cb();}

            /*  LookupService.getViewData('SystemUser',$scope.vm.selectedViewId,_pageIndex,_pageSize,$scope.vm.queryValue)
              .success(function (data) {
                  if (rtUtils.isNull(data) || data.Columns.length === 0 || data.Rows.length === 0) {
                      if (rtUtils.isFunction(cb))
                      {   cb();}

                      return;
                  }


                  var codeFieldIndex = -1;
                  var nameFieldIndex = -1;

                  for (var i = 0; i < data.Columns.length; i++) {
                      if (data.Columns[i].ColumnName === "UserCode") {
                          codeFieldIndex = i;
                      }

                      if (data.Columns[i].ColumnName === "UserName") {
                          nameFieldIndex = i;
                      }
                  }


                  for (var j = 0; j < data.Rows.length; j++) {
                      var rowData = {};
                      rowData.id = data.Rows[j].Id;

                      if (codeFieldIndex >= 0) {
                          rowData.UserCode = data.Rows[j].Fields[codeFieldIndex].Value;
                      }

                      if (nameFieldIndex >= 0) {
                          rowData.UserName = data.Rows[j].Fields[nameFieldIndex].Value;
                      }
                      $scope.vm.viewRowDataList[j + (_pageIndex - 1) * _pageSize] = rowData;
                  }

                      if(rtUtils.isFunction(cb))
                      {   cb();}

              });*/
        }

        function _selectViewMenu() {
            var selectedButtons = [];
            for (var i = 0, len = $scope.vm.viewList.length; i < len; i++) {
                selectedButtons[i] = { text: $scope.vm.viewList[i].ViewName };
            }

            var hideSheet = $ionicActionSheet.show({
                buttons: selectedButtons,
                titleText: '选择视图',
                cancelText: '取消',
                cancel: function () {
                },
                buttonClicked: function (index) {
                    $scope.vm.selectedViewId = $scope.vm.viewList[index].SavedQueryId;
                    $scope.vm.selectedViewName = $scope.vm.viewList[index].ViewName;
                    rtUtils.showLoadingToast('正在加载数据...');
                    _pageIndex = 1;

                    _loadViewData(function () {
                        rtUtils.hideLoadingToast();
                    });

                    hideSheet();
                    return true;
                }
            });
        }

        function _loadMoreData(){
            rtUtils.showLoadingToast('正在加载数据...');
            _pageIndex ++;

            _loadViewData(function () {
                rtUtils.hideLoadingToast();
            });
        }

        function _search(){
            rtUtils.showLoadingToast('正在加载数据...');
            _pageIndex = 1;

            _loadViewData(function () {
                rtUtils.hideLoadingToast();
            });
        }

        function _selectData(u){
            $scope.closeDialog();
            if(rtUtils.isFunction($scope.onDataSelected) && !rtUtils.isNull(u))
            {$scope.onDataSelected(u);}
        }
        function _removeValue(user){
            $scope.closeDialog();
            $scope.onDataSelected(user);
        }
        _init();
    }

    xrmApp.controller("LookupUserController", ['$scope', '$state', 'LookupService', '$ionicActionSheet', 'rtUtils',LookupUserController]);
})();



/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : ludwig Dong
 创建时间 : 2016/09/12
 说明     : 药品关键信息选择
 *********************************************************/

(function () {
    'use strict';
    xrmApp.controller("productLookupController", ['$scope', '$state', 'rt', productLookupController]);

    function productLookupController($scope, $state, rt) {
        var _pageIndex = 1;
        var _pageIndex_info = 1;
        var _pageSize = rt.getPaginationSize();

        _init();

        function _init() {

            $scope.qv = {};
            $scope.qv.queryValue = "";
            $scope.qv.selectinfo = {};
            $scope.qv.selectpro = {};

            $scope.vm = {};
            $scope.isLoadMore = false;
            $scope.isLoadMore_info = false;
            $scope.isselectAll = {};
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.selectData = _selectData;
            $scope.selectTab = _selectTab;
            $scope.singleselect = _singleselect;
            $scope.OkClick = _okClick;
            $scope.selPro = true;
            $scope.selImfo = false;
            $scope.product = {DataList: []};
            $scope.information = {DataList: []};
            $scope.proText = '请选择';

            setTimeout(function () {
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                $scope.isMultiple = !!$scope.lookupParams.isMultiple;
                if (rt.isNull($scope.paramslist)) {
                    $scope.paramslist = {};
                }
                _loadData(function (data) {
                    $scope.product = data;
                    $scope.$broadcast('scroll.refreshComplete');
                }, $scope.isFiltered, 1);
            }, 0);
        }

        function _selectTab(index) {
            switch (index) {
                case 0:
                    $scope.selPro = true;
                    $scope.selImfo = false;
                    break;
                case 1:
                    $scope.selPro = false;
                    $scope.selImfo = true;
                    break;
            }
        }

        function _singleselect(v) {
            if (!$scope.isMultiple) {
                var that = $scope.information.DataList;
                var model = v;
                angular.forEach(that, function (v) {
                    if (v.id != model.id) {
                        v.checked = false;
                    }
                });
            }
        }

        $scope.selectAll = function () {
            var that = $scope.information.DataList;
            angular.forEach(that, function (v) {
                if ($scope.isselectAll.checked) {
                    v.checked = true;
                } else {
                    v.checked = false;
                }
            });
        };

        function _selectData(u, buType) {
            _pageIndex_info = 1;

            if (buType == 1) {
                $scope.qv.selectpro = u;
                $scope.proText = u.name;
                $scope.selPro = false;
                $scope.selImfo = true;
                $scope.isselectAll.checked = false;
                $scope.getDataName = "Product.GetProduct_information_list";
                $scope.paramslist = {'@product_categoryId': u.id, '@queryValue': ''};
                _loadData(function (data) {
                    $scope.information = data;
                    $scope.$broadcast('scroll.refreshComplete');
                }, $scope.isFiltered, 2);
                return;
            }

            angular.forEach($scope.information.DataList, function (entity) {
                if (!entity.checked) {
                    $scope.isselectAll.checked = false;
                }
            });
        }

        function _okClick() {
            var that = $scope.information.DataList;
            $scope.qv.selectinformation = [];
            for (var i = 0, n = that.length; i < n; i++) {
                if (that[i].checked) {
                    $scope.qv.selectinformation.push(that[i]);
                }
            }
            if (rt.isFunction($scope.callback) && !rt.isNull($scope.qv.selectinformation) && $scope.qv.selectinformation.length > 0) {
                $scope.closeDialog();
                $scope.callback($scope.qv.selectinformation);
            }
        }

        function _loadData(cb, isFiltered, type) {
            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            if (isFiltered) {
                rt.filteredQueryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, type == 1 ? _pageIndex : _pageIndex_info,
                    function (data) {
                        rt.hideLoadingToast();
                        switch (type) {
                            case 1:
                                $scope.isLoadMore = data.DataList.length >= _pageSize;
                                break;
                            case 2:
                                $scope.isLoadMore_info = data.DataList.length >= _pageSize;
                                break;
                        }

                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function (msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            } else {
                rt.queryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, type == 1 ? _pageIndex : _pageIndex_info,
                    function (data) {
                        rt.hideLoadingToast();
                        switch (type) {
                            case 1:
                                $scope.isLoadMore = data.DataList.length >= _pageSize;
                                break;
                            case 2:
                                $scope.isLoadMore_info = data.DataList.length >= _pageSize;
                                break;
                        }
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function (msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.hideLoadingToast();
                        rt.showErrorToast(msg);
                    });
            }
        }

        function _viewRefresh(buType) {
            _revertCode(buType);
            switch (buType) {
                case 1:
                    _pageIndex = 1;
                    break;
                case 2:
                    _pageIndex_info = 1;
                    break;
            }
            _loadData(function (data) {
                switch (buType) {
                    case 1:
                        $scope.product = data;
                        break;
                    case 2:
                        $scope.information = data;
                        break;
                }
                $scope.$broadcast('scroll.refreshComplete');
            }, $scope.isFiltered, buType);
        }

        function _loadMoreClick(buType) {
            _revertCode(buType);
            var completeLoad = false;
            switch (buType) {
                case 1:
                    completeLoad = $scope.isLoadMore;
                    _pageIndex += 1;
                    break;
                case 2:
                    completeLoad = $scope.isLoadMore_info;
                    _pageIndex_info += 1;
                    break;
            }
            if (!completeLoad) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }
            _loadData(function (data) {
                if (!rt.isNull(data)) {
                    switch (buType) {
                        case 1:
                            if (!rt.isNull($scope.product.DataList)) {
                                $scope.product.DataList.push.apply($scope.product.DataList, data.DataList);
                            } else {
                                $scope.product.DataList = data;
                            }
                            break;
                        case 2:
                            if (!rt.isNull($scope.information.DataList)) {
                                $scope.information.DataList.push.apply($scope.information.DataList, data.DataList);
                            } else {
                                $scope.information.DataList = data;
                            }
                            break;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }, $scope.isFiltered, buType);
        }

        function _revertCode(buType) {
            switch (buType) {
                case 1:
                    //$scope.product = {DataList: []};
                    $scope.getDataName = "Product.GetProduct_information";
                    $scope.paramslist = {'@queryValue': ''};
                    ;
                    break;
                case 2:
                    //$scope.information = {DataList: []};
                    $scope.getDataName = "Product.GetProduct_information_list";
                    $scope.paramslist = {'@product_categoryId': $scope.qv.selectpro.id, '@queryValue': ''};
                    ;
                    break;
            }
        }


    }
})();



/*global angular:false */
/*global _:false */
/*global xrmApp:false */
/*global UITaskView:false */

(function () {
    'use strict';
    xrmApp.controller("singleLookupController", ['$scope','$state', 'rt', singleLookupController]);

    function singleLookupController($scope,$state, rt) {
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();
        _init();

        function _init() {
            $scope.vm = {};
            $scope.qv={};
            $scope.qv.queryValue = "";
            $scope.isLoadMore = false;
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.selectData = _selectData;
            $scope.removeValue = _removeValue;

            setTimeout(function(){
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                if(rt.isNull($scope.paramslist)){
                    $scope.paramslist = {};
                }
                _loadData(function(data){
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            },0);
        }

        function _selectData(u){
            $scope.closeDialog();
            if(rt.isFunction($scope.callback) && !rt.isNull(u))
            {$scope.callback(u);}
        }
        function _removeValue(){
            $scope.closeDialog();
            $scope.callback({});
        }

        function _loadData(cb) {
            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            if($scope.isFiltered) {
                rt.filteredQueryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        rt.hideLoadingToast();
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if(cb !== undefined){
                            cb(data);
                        }
                    },
                    function (msg) {
                        if(cb !== undefined){
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            }else {
                rt.queryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        rt.hideLoadingToast();
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if(cb !== undefined){
                            cb(data);
                        }
                    },
                    function (msg) {
                        if(cb !== undefined){
                            cb();
                        }
                        rt.hideLoadingToast();
                        rt.showErrorToast(msg);
                    });
            }
        }

        function _viewRefresh() {
            _pageIndex = 1;
            _loadData(function(data){
                $scope.vm = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _loadMoreClick() {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function(data){
                if(!rt.isNull(data)){
                    if(!rt.isNull($scope.vm.DataList)){
                        $scope.vm.DataList.push.apply($scope.vm.DataList,data.DataList);
                    }else {
                        $scope.vm = data;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        function _searchClick() {
            _pageIndex = 1;
            _loadData(function(data){
                $scope.vm = data;
            });
        }
    }
})();



/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : joe Song
 创建时间 : 2016-03-22
 说明     : 用户（单选，有头像）查询视图
 *********************************************************/

(function() {
    'use strict';
    xrmApp.controller("userLookupController", ['$scope', '$state', 'rt', userLookupController]);

    function userLookupController($scope, $state, rt) {
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();
        _init();

        function _init() {
            $scope.vm = {};
            $scope.qv = {};
            $scope.qv.queryValue = "";
            $scope.isLoadMore = false;
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.selectData = _selectData;
            $scope.removeValue = _removeValue;
            $scope.getAvatarColor =  _getAvatarColor;
            $scope.getAvatarName = _getAvatarName;
            
            setTimeout(function() {
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                if (rt.isNull($scope.paramslist)) {
                    $scope.paramslist = {};
                }
                _loadData(function(data) {
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            }, 0);
        }

        function _selectData(u) {
            $scope.closeDialog();
            if (rt.isFunction($scope.callback) && !rt.isNull(u))
            { $scope.callback(u); }
        }
        function _removeValue() {
            $scope.closeDialog();
            $scope.callback({});
        }

        function _loadData(cb) {
            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            if ($scope.isFiltered) {
                rt.filteredQueryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function(data) {
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function(msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            } else {
                rt.queryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function(data) {
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function(msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            }
        }

        function _viewRefresh() {
            _pageIndex = 1;
            _loadData(function(data) {
                $scope.vm = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _loadMoreClick() {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function(data) {
                if (!rt.isNull(data)) {
                    if (!rt.isNull($scope.vm.DataList)) {
                        $scope.vm.DataList.push.apply($scope.vm.DataList, data.DataList);
                    } else {
                        $scope.vm = data;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        function _searchClick() {
            _pageIndex = 1;
            _loadData(function(data) {
                $scope.vm = data;
            });
        }

        var _avatarColors = [
            "#2ec7c9", "#feb358", "#33bc98", "#b6a2de"
        ];

        function _getAvatarColor(index) {
            var i = index % 4;
            return _avatarColors[i];
        }

        function _getAvatarName(name) {
            if (rt.isNull(name)) {
                return "";
            }
            return name.length <= 2 ? name : name.substring(1, 3)
        }
    }
})();



/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/9/21
 说明     : 用户多选，有常用选择用户，无头像，无重置按钮
 *********************************************************/

(function () {
    'use strict';
    xrmApp.controller("userMutiLookup2Controller", ['$scope', '$state', 'rt', userMutiLookup2Controller]);

    function userMutiLookup2Controller($scope, $state, rt) {
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();
        _init();

        function _init() {
            $scope.vm = {};
            $scope.qv = {};
            $scope.qv.queryValue = "";
            $scope.isLoadMore = false;
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;

            $scope.OwnerList = '';
            $scope.okClick = _okClick;

            setTimeout(function () {
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                $scope.moduleName = $scope.lookupParams.moduleName;
                if (rt.isNull($scope.paramslist)) {
                    $scope.paramslist = {};
                }
                _loadData(function (data) {
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            }, 0);
        }

        function _okClick() {
            $scope.OwnerList = [];
            if (!rt.isNull($scope.vm.DataList)) {
                for (var i = 0, n = $scope.vm.DataList.length; i < n; i++) {
                    var v = $scope.vm.DataList[i];
                    if (v.checked) {
                        $scope.OwnerList.push(v);

                        // 保存到常用选择人员列表：合并之前已缓存的数据，并取不重复的Top5
                        $scope.userWasSelected = _.take(_.uniq([v].concat($scope.userWasSelected), function (n) {
                            return n.id
                        }), 5);
                        _.map($scope.userWasSelected, function (u) {
                            u.checked = false;
                        });
                        var str = $scope.moduleName + "WasSelected_5bf99df1-dc49-4023-a34a-7bd80a42d6bb";
                        localStorage.setItem(str, JSON.stringify($scope.userWasSelected));
                    }
                }
            }

            $scope.closeDialog();
            if (rt.isFunction($scope.callback) && !rt.isNull($scope.OwnerList)) {
                $scope.callback($scope.OwnerList);
            }
        }

        function _loadData(cb) {
            // 读取缓存，获取常用选择人员列表
            var wasSelected = localStorage.getItem($scope.moduleName + "WasSelected_5bf99df1-dc49-4023-a34a-7bd80a42d6bb");
            $scope.userWasSelected = !rt.isNull(wasSelected) ? JSON.parse(wasSelected) : [];

            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            if ($scope.isFiltered) {
                rt.filteredQueryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function (msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            } else {
                rt.queryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function (msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            }
        }

        function _viewRefresh() {
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _loadMoreClick() {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function (data) {
                if (!rt.isNull(data)) {
                    if (!rt.isNull($scope.vm.DataList)) {
                        $scope.vm.DataList.push.apply($scope.vm.DataList, data.DataList);
                    } else {
                        $scope.vm = data;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        function _searchClick() {
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;
            });
        }
    }
})();

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/8/19
 说明     : 用户多选，有常用选择用户，无头像，有重置按钮
 *********************************************************/

(function () {
    'use strict';
    xrmApp.controller("userMutiLookupController", ['$scope', '$state', 'rt', userMutiLookupController]);

    function userMutiLookupController($scope, $state, rt) {
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();
        _init();

        function _init() {
            $scope.vm = {};
            $scope.qv = {};
            $scope.qv.queryValue = "";
            $scope.isLoadMore = false;
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;

            $scope.OwnerList = '';
            $scope.okClick = _okClick;
            $scope.claerAll = _clearAll;

            setTimeout(function () {
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                $scope.moduleName = $scope.lookupParams.moduleName;
                if (rt.isNull($scope.paramslist)) {
                    $scope.paramslist = {};
                }
                _loadData(function (data) {
                    $scope.vm = data;

                    if ($scope.lookupParams.userIds.length > 0 && !rt.isNull($scope.vm.DataList)) {
                        for (var i = 0, n = $scope.vm.DataList.length; i < n; i++) {
                            for (var j = 0, m = $scope.lookupParams.userIds.length; j < m; j++) {
                                if ($scope.lookupParams.userIds[j]==$scope.vm.DataList[i].id) {
                                    $scope.vm.DataList[i].checked=true;
                                }
                            }
                        }
                    }

                    $scope.$broadcast('scroll.refreshComplete');
                });
            }, 0);
        }

        function _okClick() {
            $scope.OwnerList = '';
            var ids = [];
            if (!rt.isNull($scope.vm.DataList)) {
                for (var i = 0, n = $scope.vm.DataList.length; i < n; i++) {
                    var v = $scope.vm.DataList[i];
                    if (v.checked) {
                        ids.push(v.id);

                        // 保存到常用选择人员列表：合并之前已缓存的数据，并取不重复的Top5
                        $scope.userWasSelected = _.take(_.uniq([v].concat($scope.userWasSelected), function (n) {
                            return n.id
                        }), 5);
                        _.map($scope.userWasSelected, function (u) {
                            u.checked = false;
                        });
                        var str = $scope.moduleName + "WasSelected_5bf99df1-dc49-4023-a34a-7bd80a42d6bb";
                        localStorage.setItem(str, JSON.stringify($scope.userWasSelected));
                    }
                }
            }
            $scope.OwnerList = ids.join("','");

            $scope.closeDialog();
            if (rt.isFunction($scope.callback) && !rt.isNull($scope.OwnerList)) {
                $scope.callback($scope.OwnerList, ids);
            }
        }

        function _clearAll() {
            if (!rt.isNull($scope.vm.DataList)) {
                for (var i = 0, n = $scope.vm.DataList.length; i < n; i++) {
                    $scope.vm.DataList[i].checked = false;
                }
            }
        }

        function _loadData(cb) {
            // 读取缓存，获取常用选择人员列表
            var wasSelected = localStorage.getItem($scope.moduleName + "WasSelected_5bf99df1-dc49-4023-a34a-7bd80a42d6bb");
            $scope.userWasSelected = !rt.isNull(wasSelected) ? JSON.parse(wasSelected) : [];

            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            if ($scope.isFiltered) {
                rt.filteredQueryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function (msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            } else {
                rt.queryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function (msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            }
        }

        function _viewRefresh() {
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;

                if ($scope.lookupParams.userIds.length > 0 && !rt.isNull($scope.vm.DataList)) {
                    for (var i = 0, n = $scope.vm.DataList.length; i < n; i++) {
                        for (var j = 0, m = $scope.lookupParams.userIds.length; j < m; j++) {
                            if ($scope.lookupParams.userIds[j]==$scope.vm.DataList[i].id) {
                                $scope.vm.DataList[i].checked=true;
                            }
                        }
                    }
                }

                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _loadMoreClick() {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function (data) {
                if (!rt.isNull(data)) {
                    if (!rt.isNull($scope.vm.DataList)) {
                        $scope.vm.DataList.push.apply($scope.vm.DataList, data.DataList);

                        if ($scope.lookupParams.userIds.length > 0 && !rt.isNull($scope.vm.DataList)) {
                            for (var i = 0, n = $scope.vm.DataList.length; i < n; i++) {
                                for (var j = 0, m = $scope.lookupParams.userIds.length; j < m; j++) {
                                    if ($scope.lookupParams.userIds[j]==$scope.vm.DataList[i].id) {
                                        $scope.vm.DataList[i].checked=true;
                                    }
                                }
                            }
                        }
                    } else {
                        $scope.vm = data;

                        if ($scope.lookupParams.userIds.length > 0 && !rt.isNull($scope.vm.DataList)) {
                            for (var i = 0, n = $scope.vm.DataList.length; i < n; i++) {
                                for (var j = 0, m = $scope.lookupParams.userIds.length; j < m; j++) {
                                    if ($scope.lookupParams.userIds[j]==$scope.vm.DataList[i].id) {
                                        $scope.vm.DataList[i].checked=true;
                                    }
                                }
                            }
                        }
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        function _searchClick() {
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;
            });
        }
    }
})();

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016-10-12
 说明     : 用户（单选，有常用选择用户，有头像）查询视图
 *********************************************************/

(function () {
    'use strict';
    xrmApp.controller("userWithFrequentLookupController", ['$scope', '$state', 'rt', userWithFrequentLookupController]);

    function userWithFrequentLookupController($scope, $state, rt) {
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();
        _init();

        function _init() {
            $scope.vm = {};
            $scope.qv = {};
            $scope.qv.queryValue = "";
            $scope.isLoadMore = false;
            $scope.searchClick = _searchClick;
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.selectData = _selectData;
            $scope.removeValue = _removeValue;
            $scope.getAvatarColor = _getAvatarColor;
            $scope.getAvatarName = _getAvatarName;

            setTimeout(function () {
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                $scope.moduleName = $scope.lookupParams.moduleName;
                if (rt.isNull($scope.paramslist)) {
                    $scope.paramslist = {};
                }
                _loadData(function (data) {
                    $scope.vm = data;
                    $scope.$broadcast('scroll.refreshComplete');
                });
            }, 0);
        }

        function _selectData(u) {
            // 保存到常用选择人员列表：合并之前已缓存的数据，并取不重复的Top5
            if (!rt.isNull(u))
                $scope.userWasSelected = _.take(_.uniq([u].concat($scope.userWasSelected), function (n) {
                    return n.id
                }), 5);
            var str = $scope.moduleName + "WasSelected_5bf99df1-dc49-4023-a34a-7bd80a42d6bb";
            localStorage.setItem(str, JSON.stringify($scope.userWasSelected));

            $scope.closeDialog();
            if (rt.isFunction($scope.callback) && !rt.isNull(u)) {
                $scope.callback(u);
            }
        }

        function _removeValue() {
            $scope.closeDialog();
            $scope.callback({});
        }

        function _loadData(cb) {
            // 读取缓存，获取常用选择人员列表
            var wasSelected = localStorage.getItem($scope.moduleName + "WasSelected_5bf99df1-dc49-4023-a34a-7bd80a42d6bb");
            $scope.userWasSelected = !rt.isNull(wasSelected) ? JSON.parse(wasSelected) : [];

            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            if ($scope.isFiltered) {
                rt.filteredQueryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function (msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            } else {
                rt.queryPagingData($scope.getDataName, $scope.paramslist, $scope.orderby, _pageIndex,
                    function (data) {
                        $scope.isLoadMore = data.DataList.length >= _pageSize;
                        if (cb !== undefined) {
                            cb(data);
                        }
                    },
                    function (msg) {
                        if (cb !== undefined) {
                            cb();
                        }
                        rt.showErrorToast(msg);
                    });
            }
        }

        function _viewRefresh() {
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;
                $scope.$broadcast('scroll.refreshComplete');
            });
        }

        function _loadMoreClick() {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function (data) {
                if (!rt.isNull(data)) {
                    if (!rt.isNull($scope.vm.DataList)) {
                        $scope.vm.DataList.push.apply($scope.vm.DataList, data.DataList);
                    } else {
                        $scope.vm = data;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        }

        function _searchClick() {
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.vm = data;
            });
        }

        var _avatarColors = [
            "#2ec7c9", "#feb358", "#33bc98", "#b6a2de"
        ];

        function _getAvatarColor(index) {
            var i = index % 4;
            return _avatarColors[i];
        }

        function _getAvatarName(name) {
            if (rt.isNull(name)) {
                return "";
            }
            return name.length <= 2 ? name : name.substring(1, 3)
        }
    }
})();



/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Mona Xia  
 创建时间 : 2016/09/14
 说明     : 拜访目的多选
 *********************************************************/

(function () {
    'use strict';
    xrmApp.controller("visitpurposeLookupController", ['$scope', '$state', 'rt', visitpurposeLookupController]);

    function visitpurposeLookupController($scope, $state, rt) {
        var _pageIndex = 1;
        var _pageSize = rt.getPaginationSize();

        _init();

        function _init() {
            $scope.qv = {};
            $scope.qv.queryValue = "";
            $scope.qv.selectedPurpose = {};
            $scope.vm = {};
            $scope.isLoadMore = false;
            $scope.isselectAll = {};
            $scope.loadMoreClick = _loadMoreClick;
            $scope.viewRefresh = _viewRefresh;
            $scope.OkClick = _okClick;
            $scope.purposeList = { data: [] };

            setTimeout(function () {
                $scope.getDataName = $scope.lookupParams.getDataName;
                $scope.dataUrl = $scope.lookupParams.dataUrl;
                $scope.paramslist = $scope.lookupParams.paramslist;
                $scope.callback = $scope.lookupParams.onDataSelected;
                $scope.fields = $scope.lookupParams.fields;
                $scope.mainFieldCode = $scope.lookupParams.mainFieldCode;
                $scope.orderby = $scope.lookupParams.orderby;
                $scope.isShowLabel = !!$scope.lookupParams.isShowLabel;
                $scope.isFiltered = !!$scope.lookupParams.isFiltered;
                $scope.isMultiple = !!$scope.lookupParams.isMultiple;
                $scope.selectedDataList = $scope.$parent.vm.purposeList;
                if (rt.isNull($scope.paramslist)) {
                    $scope.paramslist = {};
                }
                _loadData(function (data) {
                    $scope.purposeList = data;
                    $scope.selectedDataList.forEach(function (item) {
                        for (var i = 0; i < $scope.purposeList.data.length; i++) {
                            if ($scope.purposeList.data[i].Value == item.Value) {
                                $scope.purposeList.data[i] = item;
                            }
                        }
                    }, this);
                    $scope.$broadcast('scroll.refreshComplete');
                });
            }, 0);
        }

        function _singleselect(v) {
            if (!$scope.isMultiple) {
                var that = $scope.purposeList.data;
                var model = v;
                angular.forEach(that, function (v) {
                    if (v.id != model.id) {
                        v.checked = false;
                    }
                });
            }
        }

        $scope.selectAll = function () {
            var that = $scope.purposeList.data;
            angular.forEach(that, function (v) {
                if ($scope.isselectAll.checked) {
                    v.checked = true;
                } else {
                    v.checked = false;
                }
            });
        };

        function _okClick() {
            var that = $scope.purposeList.data;
            $scope.qv.selectedPurpose = [];
            for (var i = 0, n = that.length; i < n; i++) {
                if (that[i].checked) {
                    $scope.qv.selectedPurpose.push(that[i]);
                }
            }
            if (rt.isFunction($scope.callback) && !rt.isNull($scope.qv.selectedPurpose) && $scope.qv.selectedPurpose.length > 0) {
                $scope.closeDialog();
                $scope.callback($scope.qv.selectedPurpose);
            }
        }

        function _loadData(cb) {
            $scope.paramslist["@queryValue"] = $scope.qv.queryValue;
            rt.showLoadingToast();
            rt.get($scope.dataUrl).then(function (resp) {
                rt.hideLoadingToast();
                $scope.isLoadMore = resp.data.length >= _pageSize;
                if (cb !== undefined) {
                    cb(resp);
                }
            });
        }

        function _viewRefresh(buType) {
            _pageIndex = 1;
            _loadData(function (data) {
                $scope.purposeList = data;
                $scope.$broadcast('scroll.refreshComplete');
            }, buType == 3 ? true : false, buType);
        }

        function _loadMoreClick(buType) {
            if (!$scope.isLoadMore) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }

            _pageIndex += 1;
            _loadData(function (data) {
                if (!rt.isNull(data)) {
                    if (!rt.isNull($scope.purposeList.data)) {
                        $scope.purposeList.data.push.apply($scope.purposeList.data, data.data);
                    } else {
                        $scope.purposeList.data = data;
                    }
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
            }, buType == 3 ? true : false);
        }

    }
})();
/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-3-24
 说明     医院定位地图Controller:
 *********************************************************/
(function () {
    'use strict';
    xrmApp.controller("mapLocationCheckController", ['$scope', '$state','$stateParams', 'rt',mapLocationCheckController]);
    function mapLocationCheckController($scope, $state,$stateParams, rt) {
        //定义百度地图的地图对象
        var _map;
        //百度地图的缩放级别，大多数情况下使用14
        var _mapScale = 14;
        //显示百度地图的div的id
        var _mapDivId = "baiduMap";
        var id=$stateParams.id;

        function init() {
            $scope.vm = {};
            $scope.$on('rt-show-modal-map',function() {
                getLocation();    
            });
        }
        
        
        /**
         * 获取当前位置
         */
        function getLocation() {
            rt.getGeolocation(function (position) {
                handlePosition(position);
            });
        }

        /**
         * 处理当前获取到的位置
         * @param position 位置信息
         */
        function handlePosition(position) {
            if (position === null) {
                return;
            }
            else {
                _map = new BMap.Map(_mapDivId);
                _map.centerAndZoom(new BMap.Point(position.longitude, position.latitude), _mapScale);
                var zoomControl = new BMap.ZoomControl();
                _map.addControl(zoomControl);//添加缩放控件
                var scaleControl = new BMap.ScaleControl();
                _map.addControl(scaleControl);//添加比例尺控件
                //创建当前位置的点
                var marker = new BMap.Marker(new BMap.Point(position.longitude, position.latitude));
                //添加到地图中
                _map.addOverlay(marker);
                $scope.vm.longitude = position.longitude;
                $scope.vm.latitude = position.latitude;
                $scope.vm.location_address = position.address;
            }
        }
        /**
         * 返回事件
         * @private
         */
        $scope.check=function()  {
            $scope.mapCb({location_address:$scope.vm.location_address,
                longitude:$scope.vm.longitude,latitude:$scope.vm.latitude});
            $scope.closeDialog();
        };
        init();
        function _backClick() {
            $state.go("app-close");
        }
    }

})();


/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-3-24
 说明     :显示地图Controller
 *********************************************************/
(function () {
    'use strict';
    xrmApp.controller("mapLocationShowController", ['$scope','$stateParams', '$state', 'rt', mapLocationShowController]);
    function mapLocationShowController($scope, $stateParams,$state, rt) {
        //定义百度地图的地图对象
        var _map;
        //百度地图的缩放级别，大多数情况下使用14
        var _mapScale = 14;
        //显示百度地图的div的id
        var _mapDivId = "baiduMap";
        var latitude = 0.0;
        var longitude = 0.0;

        function init() {
            $scope.vm = {};
            $scope.backClick = _backClick;
            
             $scope.$on('rt-show-modal-map',function() {
                latitude = $scope.sml.latitude;
                longitude = $scope.sml.longitude;
                 //获取定位消息
                 handlePosition();   
            });
            
        }

        /**
         * 处理当前获取到的位置
         * @param position 位置信息
         */
        function handlePosition() {

            if (rt.isNullOrEmptyString(longitude) || rt.isNullOrEmptyString(latitude)) {
                return;
            }
            _map = new BMap.Map(_mapDivId);
            _map.centerAndZoom(new BMap.Point(longitude, latitude), _mapScale);
            var zoomControl = new BMap.ZoomControl();
            _map.addControl(zoomControl);//添加缩放控件
            var scaleControl = new BMap.ScaleControl();
            _map.addControl(scaleControl);//添加比例尺控件

            //创建当前位置的点
            var marker = new BMap.Marker(new BMap.Point(longitude, latitude));
            //添加到地图中
            _map.addOverlay(marker);
        }

        function _backClick() {
            $state.go("bussinessaccount-read");
        }
        init();
    }
})();